2014-05-26 22:50:46 +00:00
#!/usr/bin/env bash
2013-06-18 11:34:14 +00:00
2014-01-19 19:31:14 +00:00
PROGRAM = "Osync" # Rsync based two way sync engine with fault tolerance
2015-01-16 09:55:01 +00:00
AUTHOR = "(L) 2013-2015 by Orsiris \"Ozy\" de Jong"
2014-01-19 19:31:14 +00:00
CONTACT = "http://www.netpower.fr/osync - ozy@netpower.fr"
2014-11-26 10:25:58 +00:00
PROGRAM_VERSION = 0.99RC4
2015-01-16 09:55:01 +00:00
PROGRAM_BUILD = 1601201501
2014-05-26 22:50:46 +00:00
2014-05-27 10:47:50 +00:00
## type doesn't work on platforms other than linux (bash). If if doesn't work, always assume output is not a zero exitcode
2014-05-26 22:50:46 +00:00
if ! type -p " $BASH " > /dev/null
then
echo "Please run this script only with bash shell. Tested on bash >= 3.2"
exit 127
fi
2014-05-08 10:36:36 +00:00
## allow debugging from command line with preceding ocsync with DEBUG=yes
if [ ! " $DEBUG " = = "yes" ]
then
DEBUG = no
2014-07-08 00:00:23 +00:00
SLEEP_TIME = 1
else
SLEEP_TIME = 10
2014-05-08 10:36:36 +00:00
fi
2013-06-18 11:34:14 +00:00
SCRIPT_PID = $$
LOCAL_USER = $( whoami)
LOCAL_HOST = $( hostname)
2013-07-15 22:10:23 +00:00
## Default log file until config file is loaded
2013-11-02 20:57:15 +00:00
if [ -w /var/log ]
2013-10-10 18:17:40 +00:00
then
LOG_FILE = /var/log/osync.log
else
LOG_FILE = ./osync.log
fi
2014-01-19 19:31:14 +00:00
## Default directory where to store temporary run files
2013-11-02 20:57:15 +00:00
if [ -w /dev/shm ]
2013-10-10 18:17:40 +00:00
then
RUN_DIR = /dev/shm
2013-11-02 20:57:15 +00:00
elif [ -w /tmp ]
2013-10-10 18:17:40 +00:00
then
RUN_DIR = /tmp
2013-11-02 20:57:15 +00:00
elif [ -w /var/tmp ]
2013-10-10 18:17:40 +00:00
then
RUN_DIR = /var/tmp
else
RUN_DIR = .
fi
2013-07-15 22:10:23 +00:00
2013-07-16 11:55:15 +00:00
## Working directory. Will keep current file states, backups and soft deleted files.
2013-07-15 22:10:23 +00:00
OSYNC_DIR = ".osync_workdir"
## Log a state message every $KEEP_LOGGING seconds. Should not be equal to soft or hard execution time so your log won't be unnecessary big.
KEEP_LOGGING = 1801
2013-06-18 11:34:14 +00:00
2013-08-03 21:06:09 +00:00
## Correct output of sort command (language agnostic sorting)
export LC_ALL = C
2014-09-22 19:21:37 +00:00
ALERT_LOG_FILE = $RUN_DIR /osync_lastlog
2013-06-18 11:34:14 +00:00
function Log
{
2014-03-23 20:57:57 +00:00
if [ $sync_on_changes -eq 1 ]
2013-11-18 22:50:39 +00:00
then
2014-01-19 19:31:14 +00:00
prefix = " $( date) - "
2013-11-18 22:50:39 +00:00
else
2014-01-19 19:31:14 +00:00
prefix = " TIME: $SECONDS - "
2013-11-18 22:50:39 +00:00
fi
2014-01-19 19:31:14 +00:00
echo -e " $prefix $1 " >> " $LOG_FILE "
if [ $silent -eq 0 ]
then
echo -e " $prefix $1 "
fi
2013-06-18 11:34:14 +00:00
}
function LogError
{
2013-07-15 22:10:23 +00:00
Log " $1 "
error_alert = 1
2013-06-18 11:34:14 +00:00
}
2013-07-21 19:40:55 +00:00
function LogDebug
{
if [ " $DEBUG " = = "yes" ]
then
Log " $1 "
fi
}
2014-03-09 16:54:45 +00:00
function TrapError
{
2013-07-15 22:10:23 +00:00
local JOB = " $0 "
local LINE = " $1 "
local CODE = " ${ 2 :- 1 } "
if [ $silent -eq 0 ]
then
2013-07-24 08:38:42 +00:00
echo -e " /!\ ERROR in ${ JOB } : Near line ${ LINE } , exit code ${ CODE } "
2013-07-15 22:10:23 +00:00
fi
2013-06-18 11:34:14 +00:00
}
2013-07-16 21:06:26 +00:00
function TrapStop
{
if [ $soft_stop -eq 0 ]
then
2013-07-17 09:34:05 +00:00
LogError " /!\ WARNING: Manual exit of osync is really not recommended. Sync will be in inconsistent state."
LogError " /!\ WARNING: If you are sure, please hit CTRL+C another time to quit."
2013-07-16 21:06:26 +00:00
soft_stop = 1
2013-07-17 09:34:05 +00:00
return 1
2013-07-16 21:06:26 +00:00
fi
2013-07-17 09:34:05 +00:00
if [ $soft_stop -eq 1 ]
2013-07-16 21:06:26 +00:00
then
2013-07-22 19:14:57 +00:00
LogError " /!\ WARNING: CTRL+C hit twice. Quitting osync. Please wait..."
soft_stop = 2
exit 1
2013-07-16 21:06:26 +00:00
fi
}
2013-07-17 09:34:05 +00:00
function TrapQuit
{
if [ $error_alert -ne 0 ]
then
SendAlert
2013-07-19 23:00:58 +00:00
UnlockDirectories
2013-07-22 19:14:57 +00:00
CleanUp
2013-07-21 19:40:55 +00:00
LogError "Osync finished with errros."
2014-01-19 19:31:14 +00:00
exitcode = 1
2013-07-17 09:34:05 +00:00
else
2013-07-19 23:00:58 +00:00
UnlockDirectories
2013-07-22 19:14:57 +00:00
CleanUp
2013-07-21 19:40:55 +00:00
Log "Osync finished."
2014-01-19 19:31:14 +00:00
exitcode = 0
2013-07-17 09:34:05 +00:00
fi
2014-01-19 19:31:14 +00:00
if ps -p $child_pid > /dev/null 2>& 1
then
kill -9 $child_pid
fi
if ps -p $sub_pid > /dev/null 2>& 1
then
kill -9 $sub_pid
fi
exit $exitcode
2013-07-17 09:34:05 +00:00
}
2013-07-16 21:06:26 +00:00
2013-06-18 11:34:14 +00:00
function Spinner
{
2013-07-15 22:10:23 +00:00
if [ $silent -eq 1 ]
then
return 1
fi
2013-06-18 11:34:14 +00:00
2013-07-15 22:10:23 +00:00
case $toggle
in
1)
echo -n $1 " \ "
echo -ne "\r"
toggle = "2"
; ;
2)
echo -n $1 " | "
echo -ne "\r"
toggle = "3"
; ;
3)
echo -n $1 " / "
echo -ne "\r"
toggle = "4"
; ;
*)
echo -n $1 " - "
echo -ne "\r"
toggle = "1"
; ;
esac
2013-06-18 11:34:14 +00:00
}
2013-07-19 16:15:25 +00:00
function EscapeSpaces
{
2013-07-24 08:38:42 +00:00
echo $( echo " $1 " | sed 's/ /\\ /g' )
2013-07-19 16:15:25 +00:00
}
2013-07-15 22:10:23 +00:00
function CleanUp
2013-06-18 11:34:14 +00:00
{
2013-07-17 09:34:05 +00:00
if [ " $DEBUG " != "yes" ]
then
2013-11-04 21:17:06 +00:00
rm -f $RUN_DIR /osync_*_$SCRIPT_PID
2013-07-17 09:34:05 +00:00
fi
2013-06-18 11:34:14 +00:00
}
function SendAlert
{
2013-11-03 19:29:17 +00:00
if [ " $quick_sync " = = "2" ]
then
Log "Current task is a quicksync task. Will not send any alert."
return 0
fi
2014-11-28 11:10:00 +00:00
eval " cat \" $LOG_FILE \" $COMPRESSION_PROGRAM > $ALERT_LOG_FILE "
2014-07-08 00:14:03 +00:00
MAIL_ALERT_MSG = $MAIL_ALERT_MSG $'\n\n' $( tail -n 25 " $LOG_FILE " )
if type -p mutt > /dev/null 2>& 1
2013-06-18 11:34:14 +00:00
then
2014-09-22 19:21:37 +00:00
echo $MAIL_ALERT_MSG | $( type -p mutt) -x -s " Sync alert for $SYNC_ID " $DESTINATION_MAILS -a " $ALERT_LOG_FILE "
2013-06-18 11:34:14 +00:00
if [ $? != 0 ]
then
2013-10-10 18:17:40 +00:00
Log " WARNING: Cannot send alert email via $( type -p mutt) !!! "
2013-07-15 22:10:23 +00:00
else
Log "Sent alert mail using mutt."
2013-06-18 11:34:14 +00:00
fi
elif type -p mail > /dev/null 2>& 1
2013-07-15 22:10:23 +00:00
then
2014-09-22 19:21:37 +00:00
echo $MAIL_ALERT_MSG | $( type -p mail) -a " $ALERT_LOG_FILE " -s " Sync alert for $SYNC_ID " $DESTINATION_MAILS
2013-06-18 11:34:14 +00:00
if [ $? != 0 ]
then
2013-10-10 18:17:40 +00:00
Log " WARNING: Cannot send alert email via $( type -p mail) with attachments !!! "
echo $MAIL_ALERT_MSG | $( type -p mail) -s " Sync alert for $SYNC_ID " $DESTINATION_MAILS
2013-07-15 22:10:23 +00:00
if [ $? != 0 ]
then
2013-10-10 18:17:40 +00:00
Log " WARNING: Cannot send alert email via $( type -p mail) without attachments !!! "
2013-07-15 22:10:23 +00:00
else
Log "Sent alert mail using mail command without attachment."
fi
else
Log "Sent alert mail using mail command."
2013-06-18 11:34:14 +00:00
fi
2013-10-10 18:17:40 +00:00
elif type -p sendemail > /dev/null 2>& 1
then
2015-01-17 06:40:17 +00:00
if [ " $SMTP_USER " != "" ] && [ " $SMTP_PASSWORD " != "" ]
2014-05-27 12:18:48 +00:00
then
$SMTP_OPTIONS = " -xu $SMTP_USER -xp $SMTP_PASSWORD "
else
$SMTP_OPTIONS = ""
fi
$( type -p sendemail) -f $SENDER_MAIL -t $DESTINATION_MAILS -u " Backup alert for $BACKUP_ID " -m " $MAIL_ALERT_MSG " -s $SMTP_SERVER $SMTP_OPTIONS > /dev/null 2>& 1
2013-10-10 18:17:40 +00:00
if [ $? != 0 ]
then
Log " WARNING: Cannot send alert email via $( type -p sendemail) !!! "
else
Log "Sent alert mail using sendemail command without attachment."
fi
2013-06-18 11:34:14 +00:00
else
2013-07-15 22:10:23 +00:00
Log "WARNING: Cannot send alert email (no mutt / mail present) !!!"
return 1
fi
2014-03-23 16:52:45 +00:00
2014-09-22 19:21:37 +00:00
if [ -f " $ALERT_LOG_FILE " ]
2014-03-23 16:52:45 +00:00
then
2014-09-22 19:21:37 +00:00
rm " $ALERT_LOG_FILE "
2014-03-23 16:52:45 +00:00
fi
2013-06-18 11:34:14 +00:00
}
function LoadConfigFile
{
2013-07-15 22:10:23 +00:00
if [ ! -f " $1 " ]
then
LogError " Cannot load configuration file [ $1 ]. Sync cannot start. "
2013-11-03 19:29:17 +00:00
exit 1
2013-08-04 07:47:47 +00:00
elif [ [ " $1 " != *".conf" ] ]
2013-07-15 22:10:23 +00:00
then
LogError " Wrong configuration file supplied [ $1 ]. Sync cannot start. "
2013-11-03 19:29:17 +00:00
exit 1
2013-07-15 22:10:23 +00:00
else
2013-10-10 18:17:40 +00:00
egrep '^#|^[^ ]*=[^;&]*' " $1 " > " $RUN_DIR /osync_config_ $SCRIPT_PID "
source " $RUN_DIR /osync_config_ $SCRIPT_PID "
2013-07-15 22:10:23 +00:00
fi
}
2013-06-18 11:34:14 +00:00
function CheckEnvironment
{
2013-07-15 22:10:23 +00:00
if [ " $REMOTE_SYNC " = = "yes" ]
2013-06-18 11:34:14 +00:00
then
2013-07-15 22:10:23 +00:00
if ! type -p ssh > /dev/null 2>& 1
then
LogError "ssh not present. Cannot start sync."
return 1
fi
fi
if ! type -p rsync > /dev/null 2>& 1
then
LogError "rsync not present. Sync cannot start."
return 1
fi
2013-06-18 11:34:14 +00:00
}
2014-05-26 22:50:46 +00:00
function GetLocalOS
2013-10-11 19:35:20 +00:00
{
2013-11-13 16:16:51 +00:00
LOCAL_OS_VAR = $( uname -spio 2>& 1)
2013-11-13 16:11:54 +00:00
if [ $? != 0 ]
then
2013-11-13 16:16:51 +00:00
LOCAL_OS_VAR = $( uname -v 2>& 1)
2013-11-25 08:36:49 +00:00
if [ $? != 0 ]
2013-11-14 20:20:13 +00:00
then
LOCAL_OS_VAR = ( $uname )
fi
2013-11-13 16:11:54 +00:00
fi
2014-01-19 19:31:14 +00:00
case $LOCAL_OS_VAR in
*"Linux" *)
LOCAL_OS = "Linux"
; ;
2014-05-26 22:50:46 +00:00
*"BSD" *)
LOCAL_OS = "BSD"
2014-01-19 19:31:14 +00:00
; ;
*"MINGW32" *)
LOCAL_OS = "msys"
; ;
*"Darwin" *)
LOCAL_OS = "MacOSX"
; ;
*)
LogError " Running on >> $LOCAL_OS_VAR << not supported. Please report to the author. "
exit 1
; ;
esac
LogDebug " Local OS: [ $LOCAL_OS_VAR ]. "
2014-05-26 22:50:46 +00:00
}
2014-01-19 19:31:14 +00:00
2014-05-26 22:50:46 +00:00
function GetRemoteOS
{
2013-10-11 19:35:20 +00:00
if [ " $REMOTE_SYNC " = = "yes" ]
then
2014-01-19 19:31:14 +00:00
CheckConnectivity3rdPartyHosts
CheckConnectivityRemoteHost
2015-01-16 02:03:10 +00:00
eval " $SSH_CMD \"uname -spio\" > $RUN_DIR /osync_remote_os_ $SCRIPT_PID 2>&1 " &
2013-11-03 19:29:17 +00:00
child_pid = $!
WaitForTaskCompletion $child_pid 120 240
retval = $?
if [ $retval != 0 ]
2013-11-02 20:57:15 +00:00
then
2015-01-16 09:55:01 +00:00
eval " $SSH_CMD \"uname -v\" > $RUN_DIR /osync_remote_os_ $SCRIPT_PID 2>&1 " &
2013-11-14 12:33:22 +00:00
child_pid = $!
WaitForTaskCompletion $child_pid 120 240
retval = $?
if [ $retval != 0 ]
then
2015-01-16 09:55:01 +00:00
eval " $SSH_CMD \"uname\" > $RUN_DIR /osync_remote_os_ $SCRIPT_PID 2>&1 " &
2013-11-14 12:33:22 +00:00
child_pid = $!
WaitForTaskCompletion $child_pid 120 240
retval = $?
if [ $retval != 0 ]
then
LogError "Cannot Get remote OS type."
fi
fi
2013-11-02 20:57:15 +00:00
fi
2014-05-25 17:09:30 +00:00
2014-01-19 19:31:14 +00:00
REMOTE_OS_VAR = $( cat $RUN_DIR /osync_remote_os_$SCRIPT_PID )
2014-05-25 17:09:30 +00:00
2013-11-14 12:33:22 +00:00
case $REMOTE_OS_VAR in
2014-01-19 19:31:14 +00:00
*"Linux" *)
2013-11-14 12:33:22 +00:00
REMOTE_OS = "Linux"
; ;
2014-05-26 22:50:46 +00:00
*"BSD" *)
REMOTE_OS = "BSD"
2013-11-14 12:33:22 +00:00
; ;
2014-01-19 19:31:14 +00:00
*"MINGW32" *)
2013-11-14 12:33:22 +00:00
REMOTE_OS = "msys"
; ;
2014-01-19 19:31:14 +00:00
*"Darwin" *)
2013-11-14 12:33:22 +00:00
REMOTE_OS = "MacOSX"
; ;
2014-09-22 19:21:37 +00:00
*"ssh" *| *"SSH" *)
2014-03-23 20:57:57 +00:00
LogError "Cannot connect to remote system."
exit 1
; ;
2013-11-14 12:33:22 +00:00
*)
2014-09-09 08:39:31 +00:00
LogError "Running on remote OS failed. Please report to the author if the OS is not supported."
LogError " Remote OS said:\n $REMOTE_OS_VAR "
2013-11-14 12:33:22 +00:00
exit 1
esac
2013-11-02 20:57:15 +00:00
2014-01-19 19:31:14 +00:00
LogDebug " Remote OS: [ $REMOTE_OS_VAR ]. "
fi
2013-10-11 19:35:20 +00:00
}
2013-07-18 11:39:52 +00:00
# Waits for pid $1 to complete. Will log an alert if $2 seconds passed since current task execution unless $2 equals 0.
# Will stop task and log alert if $3 seconds passed since current task execution unless $3 equals 0.
function WaitForTaskCompletion
2013-06-18 11:34:14 +00:00
{
soft_alert = 0
SECONDS_BEGIN = $SECONDS
2014-11-24 18:28:35 +00:00
while eval " $PROCESS_TEST_CMD " > /dev/null
2013-06-18 11:34:14 +00:00
do
Spinner
EXEC_TIME = $(( $SECONDS - $SECONDS_BEGIN ))
2014-05-25 17:09:30 +00:00
if [ $(( ( $EXEC_TIME + 1 ) % $KEEP_LOGGING )) -eq 0 ]
2013-06-18 11:34:14 +00:00
then
Log "Current task still running."
fi
if [ $EXEC_TIME -gt $2 ]
then
if [ $soft_alert -eq 0 ] && [ $2 != 0 ]
then
LogError "Max soft execution time exceeded for task."
soft_alert = 1
fi
if [ $EXEC_TIME -gt $3 ] && [ $3 != 0 ]
then
LogError "Max hard execution time exceeded for task. Stopping task execution."
2013-07-18 20:41:31 +00:00
kill -s SIGTERM $1
2013-07-18 11:39:52 +00:00
if [ $? = = 0 ]
then
LogError "Task stopped succesfully"
else
2013-07-18 20:41:31 +00:00
LogError "Sending SIGTERM to proces failed. Trying the hard way."
kill -9 $1
if [ $? != 0 ]
then
LogError "Could not stop task."
fi
2013-07-18 11:39:52 +00:00
fi
2013-06-18 11:34:14 +00:00
return 1
fi
2013-07-20 11:43:11 +00:00
fi
2014-07-08 00:00:23 +00:00
sleep $SLEEP_TIME
2013-06-18 11:34:14 +00:00
done
2013-07-21 19:40:55 +00:00
wait $child_pid
return $?
2013-06-18 11:34:14 +00:00
}
2013-07-18 11:39:52 +00:00
# Waits for pid $1 to complete. Will log an alert if $2 seconds passed since script start unless $2 equals 0.
# Will stop task and log alert if $3 seconds passed since script start unless $3 equals 0.
function WaitForCompletion
{
soft_alert = 0
2014-11-24 18:28:35 +00:00
while eval " $PROCESS_TEST_CMD " > /dev/null
2013-07-18 11:39:52 +00:00
do
Spinner
2014-05-25 17:09:30 +00:00
if [ $(( ( $SECONDS + 1 ) % $KEEP_LOGGING )) -eq 0 ]
2013-07-18 11:39:52 +00:00
then
Log "Current task still running."
fi
if [ $SECONDS -gt $2 ]
then
if [ $soft_alert -eq 0 ] && [ $2 != 0 ]
then
LogError "Max soft execution time exceeded for script."
soft_alert = 1
fi
if [ $SECONDS -gt $3 ] && [ $3 != 0 ]
then
LogError "Max hard execution time exceeded for script. Stopping current task execution."
2013-07-21 19:40:55 +00:00
kill -s SIGTERM $1
2013-07-18 11:39:52 +00:00
if [ $? = = 0 ]
then
LogError "Task stopped succesfully"
else
2013-07-18 20:41:31 +00:00
LogError "Sending SIGTERM to proces failed. Trying the hard way."
kill -9 $1
if [ $? != 0 ]
then
LogError "Could not stop task."
fi
2013-07-18 11:39:52 +00:00
fi
return 1
fi
fi
2014-07-08 00:00:23 +00:00
sleep $SLEEP_TIME
2013-07-18 11:39:52 +00:00
done
2013-07-21 19:40:55 +00:00
wait $child_pid
return $?
2013-07-18 11:39:52 +00:00
}
2013-06-18 11:34:14 +00:00
## Runs local command $1 and waits for completition in $2 seconds
function RunLocalCommand
{
2013-09-03 19:22:38 +00:00
if [ $dryrun -ne 0 ]
then
Log " Dryrun: Local command [ $1 ] not run. "
return 1
fi
2013-11-02 20:57:15 +00:00
Log " Running command [ $1 ] on local host. "
eval " $1 " > $RUN_DIR /osync_run_local_$SCRIPT_PID 2>& 1 &
2013-07-15 22:10:23 +00:00
child_pid = $!
2013-07-18 11:39:52 +00:00
WaitForTaskCompletion $child_pid 0 $2
2013-07-15 22:10:23 +00:00
retval = $?
if [ $retval -eq 0 ]
then
2013-11-02 20:57:15 +00:00
Log "Command succeded."
2013-07-15 22:10:23 +00:00
else
2013-11-02 20:57:15 +00:00
LogError "Command failed."
2013-07-15 22:10:23 +00:00
fi
2013-06-18 11:34:14 +00:00
2013-11-16 12:12:25 +00:00
if [ $verbose -eq 1 ] || [ $retval -ne 0 ]
2013-07-20 11:43:11 +00:00
then
2013-10-10 18:17:40 +00:00
Log " Command output:\n $( cat $RUN_DIR /osync_run_local_$SCRIPT_PID ) "
2013-07-20 11:43:11 +00:00
fi
2014-05-25 17:09:30 +00:00
2013-11-02 20:57:15 +00:00
if [ " $STOP_ON_CMD_ERROR " = = "yes" ] && [ $retval -ne 0 ]
2013-09-11 14:23:57 +00:00
then
exit 1
fi
2013-06-18 11:34:14 +00:00
}
## Runs remote command $1 and waits for completition in $2 seconds
function RunRemoteCommand
{
2013-07-15 22:10:23 +00:00
CheckConnectivity3rdPartyHosts
2013-08-24 17:51:39 +00:00
CheckConnectivityRemoteHost
2013-09-03 19:22:38 +00:00
if [ $dryrun -ne 0 ]
then
Log " Dryrun: Local command [ $1 ] not run. "
return 1
fi
2013-11-02 20:57:15 +00:00
Log " Running command [ $1 ] on remote host. "
2013-10-10 18:17:40 +00:00
eval " $SSH_CMD \" $1 \" > $RUN_DIR /osync_run_remote_ $SCRIPT_PID 2>&1 & "
2013-08-24 17:51:39 +00:00
child_pid = $!
WaitForTaskCompletion $child_pid 0 $2
retval = $?
if [ $retval -eq 0 ]
2013-07-15 22:10:23 +00:00
then
2013-11-02 20:57:15 +00:00
Log "Command succeded."
2013-08-24 17:51:39 +00:00
else
2013-11-02 20:57:15 +00:00
LogError "Command failed."
2013-08-24 17:51:39 +00:00
fi
2013-07-15 22:10:23 +00:00
2013-11-16 12:12:25 +00:00
if [ -f $RUN_DIR /osync_run_remote_$SCRIPT_PID ] && ( [ $verbose -eq 1 ] || [ $retval -ne 0 ] )
2013-08-24 17:51:39 +00:00
then
2013-10-10 18:17:40 +00:00
Log " Command output:\n $( cat $RUN_DIR /osync_run_remote_$SCRIPT_PID ) "
2013-07-15 22:10:23 +00:00
fi
2013-09-11 14:23:57 +00:00
2013-11-02 20:57:15 +00:00
if [ " $STOP_ON_CMD_ERROR " = = "yes" ] && [ $retval -ne 0 ]
2013-09-11 14:23:57 +00:00
then
exit 1
fi
2013-06-18 11:34:14 +00:00
}
function RunBeforeHook
{
2013-07-15 22:10:23 +00:00
if [ " $LOCAL_RUN_BEFORE_CMD " != "" ]
then
RunLocalCommand " $LOCAL_RUN_BEFORE_CMD " $MAX_EXEC_TIME_PER_CMD_BEFORE
fi
2013-06-18 11:34:14 +00:00
2013-07-15 22:10:23 +00:00
if [ " $REMOTE_RUN_BEFORE_CMD " != "" ]
then
RunRemoteCommand " $REMOTE_RUN_BEFORE_CMD " $MAX_EXEC_TIME_PER_CMD_BEFORE
fi
2013-06-18 11:34:14 +00:00
}
function RunAfterHook
{
if [ " $LOCAL_RUN_AFTER_CMD " != "" ]
then
2013-07-15 22:10:23 +00:00
RunLocalCommand " $LOCAL_RUN_AFTER_CMD " $MAX_EXEC_TIME_PER_CMD_AFTER
2013-06-18 11:34:14 +00:00
fi
2013-07-15 22:10:23 +00:00
if [ " $REMOTE_RUN_AFTER_CMD " != "" ]
then
RunRemoteCommand " $REMOTE_RUN_AFTER_CMD " $MAX_EXEC_TIME_PER_CMD_AFTER
fi
2013-06-18 11:34:14 +00:00
}
2013-07-15 22:10:23 +00:00
function CheckConnectivityRemoteHost
{
if [ " $REMOTE_HOST_PING " != "no" ] && [ " $REMOTE_SYNC " != "no" ]
then
2014-11-24 09:12:48 +00:00
eval " $PING_CMD $REMOTE_HOST > /dev/null 2>&1 "
2013-07-15 22:10:23 +00:00
if [ $? != 0 ]
then
LogError " Cannot ping $REMOTE_HOST "
2013-08-24 17:51:39 +00:00
exit 1
fi
fi
2013-07-15 22:10:23 +00:00
}
function CheckConnectivity3rdPartyHosts
{
if [ " $REMOTE_3RD_PARTY_HOSTS " != "" ]
then
remote_3rd_party_success = 0
2013-09-13 11:30:39 +00:00
OLD_IFS = $IFS
IFS = $' \t\n'
2013-08-24 17:51:39 +00:00
for i in $REMOTE_3RD_PARTY_HOSTS
2013-07-15 22:10:23 +00:00
do
2014-11-24 09:12:48 +00:00
eval " $PING_CMD $i > /dev/null 2>&1 "
2013-07-15 22:10:23 +00:00
if [ $? != 0 ]
then
2013-08-25 10:37:37 +00:00
Log " Cannot ping 3rd party host $i "
2013-07-15 22:10:23 +00:00
else
remote_3rd_party_success = 1
fi
done
2013-09-13 11:30:39 +00:00
IFS = $OLD_IFS
2013-07-15 22:10:23 +00:00
if [ $remote_3rd_party_success -ne 1 ]
then
LogError "No remote 3rd party host responded to ping. No internet ?"
2013-08-24 17:51:39 +00:00
exit 1
fi
2013-07-15 22:10:23 +00:00
fi
}
2013-07-20 11:43:11 +00:00
function CreateOsyncDirs
2013-07-15 22:10:23 +00:00
{
2013-07-22 19:14:57 +00:00
if ! [ -d " $MASTER_STATE_DIR " ]
2013-06-18 11:34:14 +00:00
then
2013-10-11 20:27:33 +00:00
mkdir -p " $MASTER_STATE_DIR "
2013-07-21 19:40:55 +00:00
if [ $? != 0 ]
then
LogError " Cannot create master replica state dir [ $MASTER_STATE_DIR ]. "
exit 1
fi
2013-06-18 11:34:14 +00:00
fi
2013-07-20 11:43:11 +00:00
if [ " $REMOTE_SYNC " = = "yes" ]
then
2013-08-24 17:51:39 +00:00
CheckConnectivity3rdPartyHosts
CheckConnectivityRemoteHost
2013-10-11 20:27:33 +00:00
eval " $SSH_CMD \"if ! [ -d \\\" $SLAVE_STATE_DIR \\\" ]; then $COMMAND_SUDO mkdir -p \\\" $SLAVE_STATE_DIR \\\"; fi\" " &
2013-07-24 19:03:58 +00:00
child_pid = $!
WaitForTaskCompletion $child_pid 0 1800
2013-07-20 11:43:11 +00:00
else
2013-10-11 20:27:33 +00:00
if ! [ -d " $SLAVE_STATE_DIR " ] ; then mkdir -p " $SLAVE_STATE_DIR " ; fi
2013-07-21 19:40:55 +00:00
fi
if [ $? != 0 ]
then
LogError " Cannot create slave replica state dir [ $SLAVE_STATE_DIR ]. "
exit 1
2013-07-20 11:43:11 +00:00
fi
2013-06-18 11:34:14 +00:00
}
2013-07-15 22:10:23 +00:00
function CheckMasterSlaveDirs
2013-06-18 11:34:14 +00:00
{
2013-07-22 19:14:57 +00:00
if ! [ -d " $MASTER_SYNC_DIR " ]
2013-06-18 11:34:14 +00:00
then
2013-07-21 19:40:55 +00:00
if [ " $CREATE_DIRS " = = "yes" ]
then
2013-10-11 20:27:33 +00:00
mkdir -p " $MASTER_SYNC_DIR "
2013-07-21 19:40:55 +00:00
if [ $? != 0 ]
then
LogError " Cannot create master directory [ $MASTER_SYNC_DIR ]. "
exit 1
fi
else
LogError " Master directory [ $MASTER_SYNC_DIR ] does not exist. "
exit 1
fi
2013-06-18 11:34:14 +00:00
fi
2013-07-20 11:43:11 +00:00
if [ " $REMOTE_SYNC " = = "yes" ]
2013-06-18 11:34:14 +00:00
then
2013-08-24 17:51:39 +00:00
CheckConnectivity3rdPartyHosts
CheckConnectivityRemoteHost
2013-07-21 19:40:55 +00:00
if [ " $CREATE_DIRS " = = "yes" ]
2013-07-20 11:43:11 +00:00
then
2013-10-11 20:27:33 +00:00
eval " $SSH_CMD \"if ! [ -d \\\" $SLAVE_SYNC_DIR \\\" ]; then $COMMAND_SUDO mkdir -p \\\" $SLAVE_SYNC_DIR \\\"; fi " \" &
2013-07-24 19:03:58 +00:00
child_pid = $!
WaitForTaskCompletion $child_pid 0 1800
2013-07-21 19:40:55 +00:00
if [ $? != 0 ]
then
LogError " Cannot create slave directory [ $SLAVE_SYNC_DIR ]. "
exit 1
fi
else
2013-07-24 19:03:58 +00:00
eval " $SSH_CMD \"if ! [ -d \\\" $SLAVE_SYNC_DIR \\\" ]; then exit 1; fi " \" &
child_pid = $!
WaitForTaskCompletion $child_pid 0 1800
res = $?
if [ $res != 0 ]
2013-07-21 19:40:55 +00:00
then
LogError " Slave directory [ $SLAVE_SYNC_DIR ] does not exist. "
exit 1
fi
2013-07-20 11:43:11 +00:00
fi
else
2013-07-22 19:14:57 +00:00
if [ ! -d " $SLAVE_SYNC_DIR " ]
2013-07-20 11:43:11 +00:00
then
2013-07-21 19:40:55 +00:00
if [ " $CREATE_DIRS " = = "yes" ]
then
2013-10-11 20:27:33 +00:00
mkdir -p " $SLAVE_SYNC_DIR "
2013-07-21 19:40:55 +00:00
if [ $? != 0 ]
then
LogError " Cannot create slave directory [ $SLAVE_SYNC_DIR ]. "
exit 1
else
Log " Created slave directory [ $SLAVE_SYNC_DIR ]. "
fi
else
LogError " Slave directory [ $SLAVE_SYNC_DIR ] does not exist. "
exit 1
fi
2013-07-20 11:43:11 +00:00
fi
2013-06-18 11:34:14 +00:00
fi
}
2013-07-22 19:14:57 +00:00
function CheckMinimumSpace
{
Log "Checking minimum disk space on master and slave."
MASTER_SPACE = $( df -P " $MASTER_SYNC_DIR " | tail -1 | awk '{print $4}' )
if [ $MASTER_SPACE -lt $MINIMUM_SPACE ]
then
LogError " There is not enough free space on master [ $MASTER_SPACE KB]. "
fi
2014-05-25 17:09:30 +00:00
2013-07-22 19:14:57 +00:00
if [ " $REMOTE_SYNC " = = "yes" ]
then
2013-08-24 17:51:39 +00:00
CheckConnectivity3rdPartyHosts
2014-05-25 17:09:30 +00:00
CheckConnectivityRemoteHost
2013-10-10 18:17:40 +00:00
eval " $SSH_CMD \" $COMMAND_SUDO df -P \\\" $SLAVE_SYNC_DIR \\\"\" " > $RUN_DIR /osync_slave_space_$SCRIPT_PID &
2013-07-24 19:03:58 +00:00
child_pid = $!
WaitForTaskCompletion $child_pid 0 1800
2013-10-10 18:17:40 +00:00
SLAVE_SPACE = $( cat $RUN_DIR /osync_slave_space_$SCRIPT_PID | tail -1 | awk '{print $4}' )
2013-07-22 19:14:57 +00:00
else
SLAVE_SPACE = $( df -P " $SLAVE_SYNC_DIR " | tail -1 | awk '{print $4}' )
fi
2014-05-25 17:09:30 +00:00
2013-07-22 19:14:57 +00:00
if [ $SLAVE_SPACE -lt $MINIMUM_SPACE ]
then
LogError " There is not enough free space on slave [ $SLAVE_SPACE KB]. "
fi
}
2013-07-19 16:15:25 +00:00
function RsyncExcludePattern
{
OLD_IFS = $IFS
IFS = $PATH_SEPARATOR_CHAR
for excludedir in $RSYNC_EXCLUDE_PATTERN
do
if [ " $RSYNC_EXCLUDE " = = "" ]
then
2013-07-23 18:57:38 +00:00
RSYNC_EXCLUDE = " --exclude=\" $excludedir \" "
2013-07-19 16:15:25 +00:00
else
2013-07-23 18:57:38 +00:00
RSYNC_EXCLUDE = " $RSYNC_EXCLUDE --exclude=\" $excludedir \" "
2013-07-19 16:15:25 +00:00
fi
done
IFS = $OLD_IFS
}
2014-05-08 10:36:36 +00:00
function RsyncExcludeFrom
{
2014-11-24 09:12:48 +00:00
if [ ! $RSYNC_EXCLUDE_FROM = = "" ]
then
## Check if the exclude list has a full path, and if not, add the config file path if there is one
if [ " $( basename $RSYNC_EXCLUDE_FROM ) " = = " $RSYNC_EXCLUDE_FROM " ]
then
RSYNC_EXCLUDE_FROM = $( dirname $ConfigFile ) /$RSYNC_EXCLUDE_FROM
fi
2014-05-22 16:48:40 +00:00
2014-11-24 09:12:48 +00:00
if [ -e $RSYNC_EXCLUDE_FROM ]
then
RSYNC_EXCLUDE = " $RSYNC_EXCLUDE --exclude-from=\" $RSYNC_EXCLUDE_FROM \" "
fi
fi
2014-05-08 10:36:36 +00:00
}
2013-07-21 19:40:55 +00:00
function WriteLockFiles
{
2014-01-19 19:31:14 +00:00
echo $SCRIPT_PID > " $MASTER_LOCK "
2013-07-21 19:40:55 +00:00
if [ $? != 0 ]
then
LogError "Could not set lock on master replica."
exit 1
else
Log "Locked master replica."
fi
if [ " $REMOTE_SYNC " = = "yes" ]
then
2013-08-24 17:51:39 +00:00
CheckConnectivity3rdPartyHosts
CheckConnectivityRemoteHost
2014-03-23 20:57:57 +00:00
eval " $SSH_CMD \"echo $SCRIPT_PID @ $SYNC_ID | $COMMAND_SUDO tee \\\" $SLAVE_LOCK \\\" > /dev/null \" " &
2013-07-24 19:03:58 +00:00
child_pid = $!
WaitForTaskCompletion $child_pid 0 1800
2013-07-21 19:40:55 +00:00
if [ $? != 0 ]
then
LogError "Could not set lock on remote slave replica."
exit 1
else
Log "Locked remote slave replica."
fi
else
2014-01-19 19:31:14 +00:00
echo " $SCRIPT_PID @ $SYNC_ID " > " $SLAVE_LOCK "
2013-07-21 19:40:55 +00:00
if [ $? != 0 ]
then
LogError "Couuld not set lock on local slave replica."
exit 1
else
Log "Locked local slave replica."
fi
fi
}
2013-07-19 23:00:58 +00:00
function LockDirectories
2013-07-15 22:10:23 +00:00
{
2013-11-25 12:20:53 +00:00
if [ $nolocks -eq 1 ]
then
return 0
fi
2013-07-21 19:40:55 +00:00
if [ $force_unlock -eq 1 ]
2013-07-19 23:00:58 +00:00
then
2013-07-21 19:40:55 +00:00
WriteLockFiles
if [ $? != 0 ]
2013-07-19 23:00:58 +00:00
then
exit 1
fi
2013-07-21 19:40:55 +00:00
fi
Log "Checking for replica locks."
2014-01-19 19:31:14 +00:00
if [ -f " $MASTER_LOCK " ]
2013-07-19 23:00:58 +00:00
then
2014-01-19 19:31:14 +00:00
master_lock_pid = $( cat $MASTER_LOCK )
2013-08-04 13:27:31 +00:00
LogDebug " Master lock pid present: $master_lock_pid "
ps -p$master_lock_pid > /dev/null 2>& 1
2013-07-21 19:40:55 +00:00
if [ $? != 0 ]
2013-07-19 23:00:58 +00:00
then
2013-07-21 19:40:55 +00:00
Log " There is a dead osync lock on master. Instance $master_lock_pid no longer running. Resuming. "
2013-07-19 23:00:58 +00:00
else
2013-07-21 19:40:55 +00:00
LogError " There is already a local instance of osync that locks master replica. Cannot start. If your are sure this is an error, plaese kill instance $master_lock_pid of osync. "
exit 1
2013-07-19 23:00:58 +00:00
fi
2013-07-21 19:40:55 +00:00
fi
2014-05-25 17:09:30 +00:00
2013-07-21 19:40:55 +00:00
if [ " $REMOTE_SYNC " = = "yes" ]
then
2013-08-24 17:51:39 +00:00
CheckConnectivity3rdPartyHosts
CheckConnectivityRemoteHost
2014-01-19 19:31:14 +00:00
eval " $SSH_CMD \"if [ -f \\\" $SLAVE_LOCK \\\" ]; then cat \\\" $SLAVE_LOCK \\\"; fi\" > $RUN_DIR /osync_remote_slave_lock_ $SCRIPT_PID " &
2013-07-24 19:03:58 +00:00
child_pid = $!
WaitForTaskCompletion $child_pid 0 1800
2013-11-02 20:57:15 +00:00
if [ -f $RUN_DIR /osync_remote_slave_lock_$SCRIPT_PID ]
2013-07-23 18:57:38 +00:00
then
2013-10-10 18:17:40 +00:00
slave_lock_pid = $( cat $RUN_DIR /osync_remote_slave_lock_$SCRIPT_PID | cut -d'@' -f1)
slave_lock_id = $( cat $RUN_DIR /osync_remote_slave_lock_$SCRIPT_PID | cut -d'@' -f2)
2013-07-23 18:57:38 +00:00
fi
2013-07-19 23:00:58 +00:00
else
2014-01-19 19:31:14 +00:00
if [ -f " $SLAVE_LOCK " ]
2013-07-19 23:00:58 +00:00
then
2014-01-19 19:31:14 +00:00
slave_lock_pid = $( cat " $SLAVE_LOCK " | cut -d'@' -f1)
slave_lock_id = $( cat " $SLAVE_LOCK " | cut -d'@' -f2)
2013-07-21 19:40:55 +00:00
fi
fi
if [ " $slave_lock_pid " != "" ] && [ " $slave_lock_id " != "" ]
then
LogDebug " Slave lock pid: $slave_lock_pid "
LogDebug " Slave lock id: $slave_lock_pid "
ps -p$slave_lock_pid > /dev/null
if [ $? != 0 ]
then
if [ " $slave_lock_id " = = " $SYNC_ID " ]
then
2013-07-22 09:34:58 +00:00
Log " There is a dead osync lock on slave replica that corresponds to this master sync-id. Instance $slave_lock_pid no longer running. Resuming. "
2013-07-21 19:40:55 +00:00
else
if [ " $FORCE_STRANGER_LOCK_RESUME " = = "yes" ]
then
2013-07-22 09:34:58 +00:00
LogError "WARNING: There is a dead osync lock on slave replica that does not correspond to this master sync-id. Forcing resume."
2013-07-21 19:40:55 +00:00
else
2013-07-22 09:34:58 +00:00
LogError "There is a dead osync lock on slave replica that does not correspond to this master sync-id. Will not resume."
2013-07-21 19:40:55 +00:00
exit 1
fi
fi
2013-07-19 23:00:58 +00:00
else
2013-07-21 19:40:55 +00:00
LogError " There is already a local instance of osync that locks slave replica. Cannot start. If you are sure this is an error, please kill instance $slave_lock_pid of osync. "
2013-07-19 23:00:58 +00:00
exit 1
fi
fi
2013-07-21 19:40:55 +00:00
WriteLockFiles
2013-07-15 22:10:23 +00:00
}
2013-07-19 23:00:58 +00:00
function UnlockDirectories
2013-06-18 11:34:14 +00:00
{
2013-11-25 12:20:53 +00:00
if [ $nolocks -eq 1 ]
then
return 0
fi
2013-07-21 19:40:55 +00:00
if [ " $REMOTE_SYNC " = = "yes" ]
2013-07-19 23:00:58 +00:00
then
2013-08-24 17:51:39 +00:00
CheckConnectivity3rdPartyHosts
CheckConnectivityRemoteHost
2014-01-19 19:31:14 +00:00
eval " $SSH_CMD \"if [ -f \\\" $SLAVE_LOCK \\\" ]; then $COMMAND_SUDO rm \\\" $SLAVE_LOCK \\\"; fi\" " &
2013-07-24 19:03:58 +00:00
child_pid = $!
WaitForTaskCompletion $child_pid 0 1800
2013-07-21 19:40:55 +00:00
else
2014-01-19 19:31:14 +00:00
if [ -f " $SLAVE_LOCK " ] ; then rm " $SLAVE_LOCK " ; fi
2013-07-21 19:40:55 +00:00
fi
if [ $? != 0 ]
then
LogError "Could not unlock slave replica."
else
Log "Removed slave replica lock."
fi
2014-01-19 19:31:14 +00:00
if [ -f " $MASTER_LOCK " ]
2013-07-21 19:40:55 +00:00
then
2014-01-19 19:31:14 +00:00
rm " $MASTER_LOCK "
2013-07-21 19:40:55 +00:00
if [ $? != 0 ]
2013-07-19 23:00:58 +00:00
then
2013-07-21 19:40:55 +00:00
LogError "Could not unlock master replica."
2013-07-19 23:00:58 +00:00
else
2013-07-21 19:40:55 +00:00
Log "Removed master replica lock."
2013-07-19 23:00:58 +00:00
fi
fi
2013-07-15 22:10:23 +00:00
}
2013-07-18 20:41:31 +00:00
###### Sync core functions
2013-07-16 11:55:15 +00:00
2014-01-19 19:31:14 +00:00
## Rsync does not like spaces in directory names, considering it as two different directories. Handling this schema by escaping space.
## It seems this only happens when trying to execute an rsync command through eval $rsync_cmd on a remote host.
## So i'm using unescaped $MASTER_SYNC_DIR for local rsync calls and escaped $ESC_MASTER_SYNC_DIR for remote rsync calls like user@host:$ESC_MASTER_SYNC_DIR
## The same applies for slave sync dir..............................................T.H.I.S..I.S..A..P.R.O.G.R.A.M.M.I.N.G..N.I.G.H.T.M.A.R.E
2014-05-26 22:50:46 +00:00
## tree_list(replica_path, replica type, tree_filename) Creates a list of files in replica_path for replica type (master/slave) in filename $3
2013-11-04 21:11:43 +00:00
function tree_list
{
2014-03-31 21:03:51 +00:00
Log " Creating $2 replica file list [ $1 ]. "
2014-05-26 22:50:46 +00:00
if [ " $REMOTE_SYNC " = = "yes" ] && [ " $2 " = = "slave" ]
2013-11-04 21:11:43 +00:00
then
CheckConnectivity3rdPartyHosts
CheckConnectivityRemoteHost
ESC = $( EscapeSpaces " $1 " )
2014-05-21 16:33:16 +00:00
rsync_cmd = " $( type -p $RSYNC_EXECUTABLE ) --rsync-path=\" $RSYNC_PATH \" $RSYNC_ARGS -8 --exclude \" $OSYNC_DIR \" $RSYNC_EXCLUDE -e \" $RSYNC_SSH_CMD \" --list-only $REMOTE_USER @ $REMOTE_HOST :\" $ESC /\" | grep \"^-\|^d\" | awk '{\$1=\$2=\$3=\$4=\"\" ;print}' | awk '{\$1=\$1 ;print}' | (grep -v \"^\. $\" || :) | sort > \" $RUN_DIR /osync_ $2 _ $SCRIPT_PID \" & "
2013-11-04 21:11:43 +00:00
else
2014-05-21 16:33:16 +00:00
rsync_cmd = " $( type -p $RSYNC_EXECUTABLE ) --rsync-path=\" $RSYNC_PATH \" $RSYNC_ARGS -8 --exclude \" $OSYNC_DIR \" $RSYNC_EXCLUDE --list-only \" $1 /\" | grep \"^-\|^d\" | awk '{\$1=\$2=\$3=\$4=\"\" ;print}' | awk '{\$1=\$1 ;print}' | (grep -v \"^\. $\" || :) | sort > \" $RUN_DIR /osync_ $2 _ $SCRIPT_PID \" & "
2013-11-04 21:11:43 +00:00
fi
2014-01-17 14:57:31 +00:00
LogDebug " RSYNC_CMD: $rsync_cmd "
2014-01-19 19:31:14 +00:00
## Redirect commands stderr here to get rsync stderr output in logfile
eval $rsync_cmd 2>> " $LOG_FILE "
2013-11-04 21:11:43 +00:00
child_pid = $!
WaitForCompletion $child_pid $SOFT_MAX_EXEC_TIME $HARD_MAX_EXEC_TIME
retval = $?
2014-01-19 19:31:14 +00:00
## Retval 24 = some files vanished while creating list
if ( [ $retval = = 0 ] || [ $retval = = 24 ] ) && [ -f $RUN_DIR /osync_$2 _$SCRIPT_PID ]
2013-11-04 21:11:43 +00:00
then
2014-09-22 19:21:37 +00:00
mv $RUN_DIR /osync_$2 _$SCRIPT_PID " $MASTER_STATE_DIR / $2 $3 "
2014-05-26 22:50:46 +00:00
return $?
2013-11-04 21:11:43 +00:00
else
LogError "Cannot create replica file list."
2014-05-26 22:50:46 +00:00
exit $retval
2013-07-16 21:06:26 +00:00
fi
2013-07-18 20:41:31 +00:00
}
2013-07-15 22:10:23 +00:00
2014-07-08 00:00:23 +00:00
# delete_list(replica, tree-file-after, tree-file-current, deleted-list-file, deleted-failed-list-file): Creates a list of files vanished from last run on replica $1 (master/slave)
2014-01-17 13:05:20 +00:00
function delete_list
2013-07-18 20:41:31 +00:00
{
2014-01-17 13:05:20 +00:00
Log " Creating $1 replica deleted file list. "
2014-05-27 10:47:50 +00:00
if [ -f " $MASTER_STATE_DIR / $1 $TREE_AFTER_FILENAME_NO_SUFFIX " ]
2014-01-17 13:05:20 +00:00
then
2014-05-26 22:50:46 +00:00
## Same functionnality, comm is much faster than grep but is not available on every platform
if type -p comm > /dev/null 2>& 1
2014-01-17 13:05:20 +00:00
then
2014-05-27 10:47:50 +00:00
cmd = " comm -23 \" $MASTER_STATE_DIR / $1 $TREE_AFTER_FILENAME_NO_SUFFIX \" \" $MASTER_STATE_DIR / $1 $3 \" > \" $MASTER_STATE_DIR / $1 $4 \" "
2014-01-17 13:05:20 +00:00
else
2014-05-26 22:50:46 +00:00
## The || : forces the command to have a good result
2014-05-27 10:47:50 +00:00
cmd = " (grep -F -x -v -f \" $MASTER_STATE_DIR / $1 $3 \" \" $MASTER_STATE_DIR / $1 $TREE_AFTER_FILENAME_NO_SUFFIX \" || :) > \" $MASTER_STATE_DIR / $1 $4 \" "
2014-01-17 13:05:20 +00:00
fi
2014-01-19 19:31:14 +00:00
LogDebug " CMD: $cmd "
eval $cmd
2014-07-08 00:00:23 +00:00
retval = $?
# Add delete failed file list to current delete list and then empty it
if [ -f " $MASTER_STATE_DIR / $1 $5 " ]
then
cat " $MASTER_STATE_DIR / $1 $5 " >> " $MASTER_STATE_DIR / $1 $4 "
rm -f " $MASTER_STATE_DIR / $1 $5 "
fi
return $retval
2014-01-17 13:05:20 +00:00
else
2014-05-26 22:50:46 +00:00
touch " $MASTER_STATE_DIR / $1 $4 "
2014-07-08 00:00:23 +00:00
return $retval
2014-01-17 13:05:20 +00:00
fi
2013-07-18 20:41:31 +00:00
}
2013-07-15 22:10:23 +00:00
2014-05-26 22:50:46 +00:00
# sync_update(source replica, destination replica, delete_list_filename)
2014-01-19 19:31:14 +00:00
function sync_update
2013-07-18 20:41:31 +00:00
{
2014-01-19 19:31:14 +00:00
Log " Updating $2 replica. "
if [ " $1 " = = "master" ]
then
SOURCE_DIR = " $MASTER_SYNC_DIR "
ESC_SOURCE_DIR = $( EscapeSpaces " $MASTER_SYNC_DIR " )
DEST_DIR = " $SLAVE_SYNC_DIR "
ESC_DEST_DIR = $( EscapeSpaces " $SLAVE_SYNC_DIR " )
BACKUP_DIR = " $SLAVE_BACKUP "
else
SOURCE_DIR = " $SLAVE_SYNC_DIR "
ESC_SOURCE_DIR = $( EscapeSpaces " $SLAVE_SYNC_DIR " )
DEST_DIR = " $MASTER_SYNC_DIR "
ESC_DEST_DIR = $( EscapeSpaces " $MASTER_SYNC_DIR " )
BACKUP_DIR = " $MASTER_BACKUP "
fi
2014-05-25 17:09:30 +00:00
2013-07-21 19:40:55 +00:00
if [ " $REMOTE_SYNC " = = "yes" ]
then
2013-08-24 17:51:39 +00:00
CheckConnectivity3rdPartyHosts
CheckConnectivityRemoteHost
2014-01-19 19:31:14 +00:00
if [ " $1 " = = "master" ]
2014-01-17 13:05:20 +00:00
then
2014-05-26 22:50:46 +00:00
rsync_cmd = " $( type -p $RSYNC_EXECUTABLE ) --rsync-path=\" $RSYNC_PATH \" $RSYNC_ARGS $SYNC_OPTS -e \" $RSYNC_SSH_CMD \" $BACKUP_DIR --exclude \" $OSYNC_DIR \" $RSYNC_EXCLUDE --exclude-from=\" $MASTER_STATE_DIR / $1 $3 \" --exclude-from=\" $MASTER_STATE_DIR / $2 $3 \" \" $SOURCE_DIR /\" $REMOTE_USER @ $REMOTE_HOST :\" $ESC_DEST_DIR /\" > $RUN_DIR /osync_update_ $2 _replica_ $SCRIPT_PID 2>&1 & "
2014-01-17 13:05:20 +00:00
else
2014-05-26 22:50:46 +00:00
rsync_cmd = " $( type -p $RSYNC_EXECUTABLE ) --rsync-path=\" $RSYNC_PATH \" $RSYNC_ARGS $SYNC_OPTS -e \" $RSYNC_SSH_CMD \" $BACKUP_DIR --exclude \" $OSYNC_DIR \" $RSYNC_EXCLUDE --exclude-from=\" $MASTER_STATE_DIR / $2 $3 \" --exclude-from=\" $MASTER_STATE_DIR / $1 $3 \" $REMOTE_USER @ $REMOTE_HOST :\" $ESC_SOURCE_DIR /\" \" $DEST_DIR /\" > $RUN_DIR /osync_update_ $2 _replica_ $SCRIPT_PID 2>&1 & "
2014-01-17 13:05:20 +00:00
fi
2013-07-21 19:40:55 +00:00
else
2014-05-26 22:50:46 +00:00
rsync_cmd = " $( type -p $RSYNC_EXECUTABLE ) --rsync-path=\" $RSYNC_PATH \" $RSYNC_ARGS $SYNC_OPTS $BACKUP_DIR --exclude \" $OSYNC_DIR \" $RSYNC_EXCLUDE --exclude-from=\" $MASTER_STATE_DIR / $1 $3 \" --exclude-from=\" $MASTER_STATE_DIR / $2 $3 \" \" $SOURCE_DIR /\" \" $DEST_DIR /\" > $RUN_DIR /osync_update_ $2 _replica_ $SCRIPT_PID 2>&1 & "
2013-07-23 18:57:38 +00:00
fi
2014-01-17 14:57:31 +00:00
LogDebug " RSYNC_CMD: $rsync_cmd "
2013-07-24 08:38:42 +00:00
eval " $rsync_cmd "
2013-07-18 20:41:31 +00:00
child_pid = $!
WaitForCompletion $child_pid $SOFT_MAX_EXEC_TIME $HARD_MAX_EXEC_TIME
retval = $?
2014-01-19 19:31:14 +00:00
if [ $verbose -eq 1 ] && [ -f $RUN_DIR /osync_update_$2 _replica_$SCRIPT_PID ]
2013-07-19 23:00:58 +00:00
then
2014-01-19 19:31:14 +00:00
Log " List:\n $( cat $RUN_DIR /osync_update_$2 _replica_$SCRIPT_PID ) "
2013-07-19 23:00:58 +00:00
fi
2014-01-19 19:31:14 +00:00
if [ $retval != 0 ] && [ $retval != 24 ]
2013-07-18 20:41:31 +00:00
then
2014-01-19 19:31:14 +00:00
LogError " Updating $2 replica failed. Stopping execution. "
if [ $verbose -eq 0 ] && [ -f $RUN_DIR /osync_update_$2 _replica_$SCRIPT_PID ]
2014-01-17 13:05:20 +00:00
then
2014-01-19 19:31:14 +00:00
LogError " Rsync output:\n $( cat $RUN_DIR /osync_update_$2 _replica_$SCRIPT_PID ) "
2014-01-17 13:05:20 +00:00
fi
2014-05-26 22:50:46 +00:00
exit $retval
2014-01-19 19:31:14 +00:00
else
Log " Updating $2 replica succeded. "
2014-05-26 22:50:46 +00:00
return 0
2013-07-18 20:41:31 +00:00
fi
}
2014-07-08 00:00:23 +00:00
# delete_local(replica dir, delete file list, delete dir, delete failed file)
2014-05-25 15:51:05 +00:00
function _delete_local
2013-07-18 20:41:31 +00:00
{
2014-05-25 15:51:05 +00:00
## On every run, check wheter the next item is already deleted because it's included in a directory already deleted
previous_file = ""
OLD_IFS = $IFS
IFS = $'\r\n'
2014-05-25 17:09:30 +00:00
for files in $( cat " $MASTER_STATE_DIR / $2 " )
2014-05-25 15:51:05 +00:00
do
if [ [ " $files " != " $previous_file / " * ] ] && [ " $files " != "" ]
then
if [ " $SOFT_DELETE " != "no" ]
then
if [ ! -d " $REPLICA_DIR $3 " ]
then
mkdir -p " $REPLICA_DIR $3 "
if [ $? != 0 ]
then
LogError "Cannot create replica deletion directory."
fi
fi
if [ $verbose -eq 1 ]
then
Log " Soft deleting $REPLICA_DIR $files "
fi
2014-05-25 17:09:30 +00:00
2014-05-25 15:51:05 +00:00
if [ $dryrun -ne 1 ]
then
mv " $REPLICA_DIR $files " " $REPLICA_DIR $3 "
if [ $? != 0 ]
then
LogError " Cannot move $REPLICA_DIR $files to deletion directory. "
2014-07-08 00:00:23 +00:00
echo " $files " >> " $MASTER_STATE_DIR / $4 "
2014-05-25 15:51:05 +00:00
fi
fi
else
if [ $verbose -eq 1 ]
then
Log " Deleting $REPLICA_DIR $files "
fi
if [ $dryrun -ne 1 ]
then
rm -rf " $REPLICA_DIR $files "
if [ $? != 0 ]
then
LogError " Cannot delete $REPLICA_DIR $files "
2014-07-08 00:00:23 +00:00
echo " $files " >> " $MASTER_STATE_DIR / $4 "
2014-05-25 15:51:05 +00:00
fi
fi
fi
previous_file = " $files "
fi
done
IFS = $OLD_IFS
}
2014-07-08 00:00:23 +00:00
# delete_remote(replica dir, delete file list, delete dir, delete fail file list)
2014-05-25 15:51:05 +00:00
function _delete_remote
{
## This is a special coded function. Need to redelcare local functions on remote host, passing all needed variables as escaped arguments to ssh command.
## Anything beetween << ENDSSH and ENDSSH will be executed remotely
# Additionnaly, we need to copy the deletetion list to the remote state folder
2014-05-25 17:09:30 +00:00
ESC_DEST_DIR = " $( EscapeSpaces " $SLAVE_STATE_DIR " ) "
rsync_cmd = " $( type -p $RSYNC_EXECUTABLE ) --rsync-path=\" $RSYNC_PATH \" $SYNC_OPTS -e \" $RSYNC_SSH_CMD \" \" $MASTER_STATE_DIR / $2 \" $REMOTE_USER @ $REMOTE_HOST :\" $ESC_DEST_DIR /\" > $RUN_DIR /osync_remote_deletion_list_copy_ $SCRIPT_PID 2>&1 "
2014-07-08 00:00:23 +00:00
LogDebug " RSYNC_CMD: $rsync_cmd "
2014-05-25 17:09:30 +00:00
eval $rsync_cmd 2>> " $LOG_FILE "
2014-05-25 15:51:05 +00:00
if [ $? != 0 ]
2014-01-19 19:31:14 +00:00
then
2014-05-25 15:51:05 +00:00
LogError "Cannot copy the deletion list to remote replica."
if [ -f $RUN_DIR /osync_remote_deletion_list_copy_$SCRIPT_PID ]
then
LogError " $( cat $RUN_DIR /osync_remote_deletion_list_copy_$SCRIPT_PID ) "
fi
exit 1
2014-01-19 19:31:14 +00:00
fi
2014-05-25 15:51:05 +00:00
2014-07-08 00:00:23 +00:00
$SSH_CMD error_alert = 0 sync_on_changes = $sync_on_changes silent = $silent DEBUG = $DEBUG dryrun = $dryrun verbose = $verbose COMMAND_SUDO = $COMMAND_SUDO FILE_LIST = " $( EscapeSpaces " $SLAVE_STATE_DIR / $2 " ) " REPLICA_DIR = " $( EscapeSpaces " $REPLICA_DIR " ) " DELETE_DIR = " $( EscapeSpaces " $DELETE_DIR " ) " FAILED_DELETE_LIST = " $( EscapeSpaces " $SLAVE_STATE_DIR / $4 " ) " 'bash -s' << 'ENDSSH' > $RUN_DIR /osync_remote_deletion_$SCRIPT_PID 2>& 1 &
2014-05-25 15:51:05 +00:00
## The following lines are executed remotely
function Log
{
if [ $sync_on_changes -eq 1 ]
then
prefix = " $( date) - "
else
prefix = " R-TIME: $SECONDS - "
fi
if [ $silent -eq 0 ]
then
echo -e " $prefix $1 "
fi
}
function LogError
{
Log " $1 "
error_alert = 1
}
2014-07-08 00:00:23 +00:00
## Empty earlier failed delete list
> " $FAILED_DELETE_LIST "
2014-05-25 15:51:05 +00:00
## On every run, check wheter the next item is already deleted because it's included in a directory already deleted
previous_file = ""
2014-09-22 19:21:37 +00:00
OLD_IFS = $IFS
IFS = $'\r\n'
2014-05-25 15:51:05 +00:00
for files in $( cat " $FILE_LIST " )
do
if [ [ " $files " != " $previous_file / " * ] ] && [ " $files " != "" ]
then
if [ ! -d " $REPLICA_DIR $DELETE_DIR " ]
then
$COMMAND_SUDO mkdir -p " $REPLICA_DIR $DELETE_DIR "
if [ $? != 0 ]
then
LogError "Cannot create replica deletion directory."
fi
fi
if [ " $SOFT_DELETE " != "no" ]
then
if [ $verbose -eq 1 ]
then
Log " Soft deleting $REPLICA_DIR $files "
fi
if [ $dryrun -ne 1 ]
then
2014-05-25 17:09:30 +00:00
$COMMAND_SUDO mv " $REPLICA_DIR $files " " $REPLICA_DIR $DELETE_DIR "
2014-05-25 15:51:05 +00:00
if [ $? != 0 ]
then
LogError " Cannot move $REPLICA_DIR $files to deletion directory. "
2014-07-08 00:00:23 +00:00
echo " $files " >> " $FAILED_DELETE_LIST "
2014-05-25 15:51:05 +00:00
fi
fi
else
if [ $verbose -eq 1 ]
then
Log " Deleting $REPLICA_DIR $files "
fi
if [ $dryrun -ne 1 ]
then
$COMMAND_SUDO rm -rf " $REPLICA_DIR $files "
if [ $? != 0 ]
then
LogError " Cannot delete $REPLICA_DIR $files "
2014-07-08 00:00:23 +00:00
echo " $files " >> " $SLAVE_STATE_DIR / $FAILED_DELETE_LIST "
2014-05-25 15:51:05 +00:00
fi
fi
fi
previous_file = " $files "
fi
done
2014-09-22 19:21:37 +00:00
IFS = $OLD_IFS
2014-05-25 15:51:05 +00:00
ENDSSH
2014-07-08 00:00:23 +00:00
2014-05-25 17:09:30 +00:00
## Need to add a trivial sleep time to give ssh time to log to local file
sleep 5
2014-07-08 00:00:23 +00:00
## Copy back the deleted failed file list
ESC_SOURCE_FILE = " $( EscapeSpaces " $SLAVE_STATE_DIR / $4 " ) "
rsync_cmd = " $( type -p $RSYNC_EXECUTABLE ) --rsync-path=\" $RSYNC_PATH \" $SYNC_OPTS -e \" $RSYNC_SSH_CMD \" $REMOTE_USER @ $REMOTE_HOST :\" $ESC_SOURCE_FILE \" \" $MASTER_STATE_DIR \" > $RUN_DIR /osync_remote_failed_deletion_list_copy_ $SCRIPT_PID "
LogDebug " RSYNC_CMD: $rsync_cmd "
eval $rsync_cmd 2>> " $LOG_FILE "
if [ $? != 0 ]
then
LogError "Cannot copy back the failed deletion list to master replica."
if [ -f $RUN_DIR /osync_remote_failed_deletion_list_copy_$SCRIPT_PID ]
then
LogError " $( cat $RUN_DIR /osync_remote_failed_deletion_list_copy_$SCRIPT_PID ) "
fi
exit 1
fi
2014-05-25 15:51:05 +00:00
exit $?
}
2014-07-08 00:00:23 +00:00
# delete_propagation(replica name, deleted_list_filename, deleted_failed_file_list)
2014-05-25 15:51:05 +00:00
# replica name = "master" / "slave"
function deletion_propagation
{
Log " Propagating deletions to $1 replica. "
2014-05-25 17:09:30 +00:00
2014-05-25 15:51:05 +00:00
if [ " $1 " = = "master" ]
2013-07-21 19:40:55 +00:00
then
2014-05-25 15:51:05 +00:00
REPLICA_DIR = " $MASTER_SYNC_DIR "
DELETE_DIR = " $MASTER_DELETE_DIR "
2014-07-08 00:00:23 +00:00
_delete_local " $REPLICA_DIR " " slave $2 " " $DELETE_DIR " " slave $3 " &
2014-05-25 15:51:05 +00:00
child_pid = $!
WaitForCompletion $child_pid $SOFT_MAX_EXEC_TIME $HARD_MAX_EXEC_TIME
retval = $?
2014-05-26 22:50:46 +00:00
if [ $retval != 0 ]
2014-05-25 15:51:05 +00:00
then
LogError " Deletion on replica $1 failed. "
exit 1
2014-05-25 17:09:30 +00:00
fi
2013-07-18 20:41:31 +00:00
else
2014-05-25 15:51:05 +00:00
REPLICA_DIR = " $SLAVE_SYNC_DIR "
DELETE_DIR = " $SLAVE_DELETE_DIR "
2013-07-19 23:00:58 +00:00
2014-05-25 15:51:05 +00:00
if [ " $REMOTE_SYNC " = = "yes" ]
then
2014-07-08 00:00:23 +00:00
_delete_remote " $REPLICA_DIR " " master $2 " " $DELETE_DIR " " master $3 " &
2014-05-25 15:51:05 +00:00
else
2014-07-08 00:00:23 +00:00
_delete_local " $REPLICA_DIR " " master $2 " " $DELETE_DIR " " master $3 " &
2014-05-25 15:51:05 +00:00
fi
child_pid = $!
WaitForCompletion $child_pid $SOFT_MAX_EXEC_TIME $HARD_MAX_EXEC_TIME
retval = $?
if [ $retval = = 0 ]
2013-08-25 10:37:37 +00:00
then
2014-05-25 17:09:30 +00:00
if [ -f $RUN_DIR /osync_remote_deletion_$SCRIPT_PID ] && [ $verbose -eq 1 ]
then
Log " Remote:\n $( cat $RUN_DIR /osync_remote_deletion_$SCRIPT_PID ) "
fi
2014-05-26 22:50:46 +00:00
return $retval
2014-05-25 15:51:05 +00:00
else
LogError "Deletion on remote system failed."
if [ -f $RUN_DIR /osync_remote_deletion_$SCRIPT_PID ]
then
2014-05-25 17:09:30 +00:00
LogError " Remote:\n $( cat $RUN_DIR /osync_remote_deletion_$SCRIPT_PID ) "
2014-05-25 15:51:05 +00:00
fi
2014-05-26 22:50:46 +00:00
exit 1
2014-05-25 15:51:05 +00:00
fi
2013-07-24 08:38:42 +00:00
fi
2013-07-18 20:41:31 +00:00
}
2014-05-26 22:50:46 +00:00
###### Sync function in 5 steps of each 2 runs (functions above)
######
###### Step 1: Create current tree list for master and slave replicas (Steps 1M and 1S)
###### Step 2: Create deleted file list for master and slave replicas (Steps 2M and 2S)
###### Step 3: Update master and slave replicas (Steps 3M and 3S, order depending on conflict prevalence)
###### Step 4: Deleted file propagation to master and slave replicas (Steps 4M and 4S)
###### Step 5: Create after run tree list for master and slave replicas (Steps 5M and 5S)
2013-07-18 20:41:31 +00:00
function Sync
{
Log "Starting synchronization task."
2013-08-24 17:51:39 +00:00
CheckConnectivity3rdPartyHosts
CheckConnectivityRemoteHost
2013-07-18 20:41:31 +00:00
2014-05-26 22:50:46 +00:00
if [ -f " $MASTER_LAST_ACTION " ] && [ " $RESUME_SYNC " != "no" ]
2013-07-18 20:41:31 +00:00
then
2014-05-08 20:08:15 +00:00
resume_sync = $( cat " $MASTER_LAST_ACTION " )
if [ -f " $MASTER_RESUME_COUNT " ]
2013-07-19 10:49:40 +00:00
then
2014-05-08 20:08:15 +00:00
resume_count = $( cat " $MASTER_RESUME_COUNT " )
2013-07-19 10:49:40 +00:00
else
resume_count = 0
fi
if [ $resume_count -lt $RESUME_TRY ]
2013-07-18 20:41:31 +00:00
then
2013-07-19 10:49:40 +00:00
if [ " $resume_sync " != "sync.success" ]
then
2014-05-26 22:50:46 +00:00
Log " WARNING: Trying to resume aborted osync execution on $( $STAT_CMD " $MASTER_LAST_ACTION " ) at task [ $resume_sync ]. [ $resume_count ] previous tries. "
echo $(( $resume_count + 1 )) > " $MASTER_RESUME_COUNT "
2013-07-19 10:49:40 +00:00
else
resume_sync = none
fi
2013-07-18 20:41:31 +00:00
else
2013-07-19 23:00:58 +00:00
Log " Will not resume aborted osync execution. Too much resume tries [ $resume_count ]. "
2014-05-26 22:50:46 +00:00
echo "noresume" > " $MASTER_LAST_ACTION "
echo "0" > " $MASTER_RESUME_COUNT "
2013-07-18 20:41:31 +00:00
resume_sync = none
fi
else
resume_sync = none
fi
2013-07-30 22:18:39 +00:00
################################################################################################################################################# Actual sync begins here
2014-05-08 10:36:36 +00:00
## This replaces the case statement because ;& operator is not supported in bash 3.2... Code is more messy than case :(
2013-08-04 13:27:31 +00:00
if [ " $resume_sync " = = "none" ] || [ " $resume_sync " = = "noresume" ] || [ " $resume_sync " = = "master-replica-tree.fail" ]
2013-07-30 22:18:39 +00:00
then
2013-11-04 21:11:43 +00:00
#master_tree_current
2014-05-26 22:50:46 +00:00
tree_list " $MASTER_SYNC_DIR " master " $TREE_CURRENT_FILENAME "
if [ $? = = 0 ]
then
echo " ${ SYNC_ACTION [0] } .success " > " $MASTER_LAST_ACTION "
else
echo " ${ SYNC_ACTION [0] } .fail " > " $MASTER_LAST_ACTION "
fi
2013-07-30 22:18:39 +00:00
resume_sync = "resumed"
fi
2014-05-26 22:50:46 +00:00
if [ " $resume_sync " = = "resumed" ] || [ " $resume_sync " = = " ${ SYNC_ACTION [0] } .success " ] || [ " $resume_sync " = = " ${ SYNC_ACTION [1] } .fail " ]
2013-07-30 22:18:39 +00:00
then
2013-11-04 21:11:43 +00:00
#slave_tree_current
2014-05-26 22:50:46 +00:00
tree_list " $SLAVE_SYNC_DIR " slave " $TREE_CURRENT_FILENAME "
if [ $? = = 0 ]
then
echo " ${ SYNC_ACTION [1] } .success " > " $MASTER_LAST_ACTION "
else
echo " ${ SYNC_ACTION [1] } .fail " > " $MASTER_LAST_ACTION "
fi
2013-07-30 22:18:39 +00:00
resume_sync = "resumed"
fi
2014-05-26 22:50:46 +00:00
if [ " $resume_sync " = = "resumed" ] || [ " $resume_sync " = = " ${ SYNC_ACTION [1] } .success " ] || [ " $resume_sync " = = " ${ SYNC_ACTION [2] } .fail " ]
2013-07-30 22:18:39 +00:00
then
2014-07-08 00:00:23 +00:00
delete_list master " $TREE_AFTER_FILENAME " " $TREE_CURRENT_FILENAME " " $DELETED_LIST_FILENAME " " $FAILED_DELETE_LIST_FILENAME "
2014-05-26 22:50:46 +00:00
if [ $? = = 0 ]
then
echo " ${ SYNC_ACTION [2] } .success " > " $MASTER_LAST_ACTION "
else
echo " ${ SYNc_ACTION [2] } .fail " > " $MASTER_LAST_ACTION "
fi
2013-07-30 22:18:39 +00:00
resume_sync = "resumed"
fi
2014-05-26 22:50:46 +00:00
if [ " $resume_sync " = = "resumed" ] || [ " $resume_sync " = = " ${ SYNC_ACTION [2] } .success " ] || [ " $resume_sync " = = " ${ SYNC_ACTION [3] } .fail " ]
2013-07-30 22:18:39 +00:00
then
2014-07-08 00:00:23 +00:00
delete_list slave " $TREE_AFTER_FILENAME " " $TREE_CURRENT_FILENAME " " $DELETED_LIST_FILENAME " " $FAILED_DELETE_LIST_FILENAME "
2014-05-26 22:50:46 +00:00
if [ $? = = 0 ]
then
echo " ${ SYNC_ACTION [3] } .success " > " $MASTER_LAST_ACTION "
else
echo " ${ SYNC_ACTION [3] } .fail " > " $MASTER_LAST_ACTION "
fi
2013-07-30 22:18:39 +00:00
resume_sync = "resumed"
fi
2014-11-24 23:38:03 +00:00
if [ " $resume_sync " = = "resumed" ] || [ " $resume_sync " = = " ${ SYNC_ACTION [3] } .success " ] || [ " $resume_sync " = = " ${ SYNC_ACTION [4] } .fail " ] || [ " $resume_sync " = = " ${ SYNC_ACTION [5] } .fail " ] || [ " $resume_sync " = = " ${ SYNC_ACTION [4] } .success " ] || [ " $resume_sync " = = " ${ SYNC_ACTION [5] } .success " ]
2013-07-30 22:18:39 +00:00
then
if [ " $CONFLICT_PREVALANCE " != "master" ]
then
2014-05-26 22:50:46 +00:00
if [ " $resume_sync " = = "resumed" ] || [ " $resume_sync " = = " ${ SYNC_ACTION [3] } .success " ] || [ " $resume_sync " = = " ${ SYNC_ACTION [4] } .fail " ]
2013-07-30 22:18:39 +00:00
then
2014-05-26 22:50:46 +00:00
sync_update slave master " $DELETED_LIST_FILENAME "
if [ $? = = 0 ]
then
echo " ${ SYNC_ACTION [4] } .success " > " $MASTER_LAST_ACTION "
else
echo " ${ SYNC_ACTION [4] } .fail " > " $MASTER_LAST_ACTION "
fi
2013-07-30 22:18:39 +00:00
resume_sync = "resumed"
fi
2014-05-26 22:50:46 +00:00
if [ " $resume_sync " = = "resumed" ] || [ " $resume_sync " = = " ${ SYNC_ACTION [4] } .success " ] || [ " $resume_sync " = = " ${ SYNC_ACTION [5] } .fail " ]
2013-07-30 22:18:39 +00:00
then
2014-05-26 22:50:46 +00:00
sync_update master slave " $DELETED_LIST_FILENAME "
if [ $? = = 0 ]
then
echo " ${ SYNC_ACTION [5] } .success " > " $MASTER_LAST_ACTION "
else
echo " ${ SYNC_ACTION [5] } .fail " > " $MASTER_LAST_ACTION "
fi
2013-07-30 22:18:39 +00:00
resume_sync = "resumed"
fi
else
2014-05-26 22:50:46 +00:00
if [ " $resume_sync " = = "resumed" ] || [ " $resume_sync " = = " ${ SYNC_ACTION [3] } .success " ] || [ " $resume_sync " = = " ${ SYNC_ACTION [5] } .fail " ]
2013-07-30 22:18:39 +00:00
then
2014-05-26 22:50:46 +00:00
sync_update master slave " $DELETED_LIST_FILENAME "
if [ $? = = 0 ]
then
echo " ${ SYNC_ACTION [5] } .success " > " $MASTER_LAST_ACTION "
else
echo " ${ SYNC_ACTION [5] } .fail " > " $MASTER_LAST_ACTION "
fi
2013-07-30 22:18:39 +00:00
resume_sync = "resumed"
fi
2014-05-26 22:50:46 +00:00
if [ " $resume_sync " = = "resumed" ] || [ " $resume_sync " = = " ${ SYNC_ACTION [5] } .success " ] || [ " $resume_sync " = = " ${ SYNC_ACTION [4] } .fail " ]
2013-07-30 22:18:39 +00:00
then
2014-05-26 22:50:46 +00:00
sync_update slave master " $DELETED_LIST_FILENAME "
if [ $? = = 0 ]
then
echo " ${ SYNC_ACTION [4] } .success " > " $MASTER_LAST_ACTION "
else
echo " ${ SYNC_ACTION [4] } .fail " > " $MASTER_LAST_ACTION "
fi
2013-07-30 22:18:39 +00:00
resume_sync = "resumed"
fi
fi
fi
2014-05-26 22:50:46 +00:00
if [ " $resume_sync " = = "resumed" ] || [ " $resume_sync " = = " ${ SYNC_ACTION [5] } .success " ] || [ " $resume_sync " = = " ${ SYNC_ACTION [4] } .success " ] || [ " $resume_sync " = = " ${ SYNC_ACTION [6] } .fail " ]
2013-07-30 22:18:39 +00:00
then
2014-07-08 00:00:23 +00:00
deletion_propagation slave " $DELETED_LIST_FILENAME " " $FAILED_DELETE_LIST_FILENAME "
2014-05-26 22:50:46 +00:00
if [ $? = = 0 ]
then
echo " ${ SYNC_ACTION [6] } .success " > " $MASTER_LAST_ACTION "
else
echo " ${ SYNC_ACTION [6] } .fail " > " $MASTER_LAST_ACTION "
fi
2013-07-30 22:18:39 +00:00
resume_sync = "resumed"
fi
2014-05-26 22:50:46 +00:00
if [ " $resume_sync " = = "resumed" ] || [ " $resume_sync " = = " ${ SYNC_ACTION [6] } .success " ] || [ " $resume_sync " = = " ${ SYNC_ACTION [7] } .fail " ]
2013-07-30 22:18:39 +00:00
then
2014-07-08 00:00:23 +00:00
deletion_propagation master " $DELETED_LIST_FILENAME " " $FAILED_DELETE_LIST_FILENAME "
2014-05-26 22:50:46 +00:00
if [ $? = = 0 ]
then
echo " ${ SYNC_ACTION [7] } .success " > " $MASTER_LAST_ACTION "
else
echo " ${ SYNC_ACTION [7] } .fail " > " $MASTER_LAST_ACTION "
fi
2013-07-30 22:18:39 +00:00
resume_sync = "resumed"
fi
2014-05-26 22:50:46 +00:00
if [ " $resume_sync " = = "resumed" ] || [ " $resume_sync " = = " ${ SYNC_ACTION [7] } .success " ] || [ " $resume_sync " = = " ${ SYNC_ACTION [8] } .fail " ]
2013-07-30 22:18:39 +00:00
then
2013-11-04 21:11:43 +00:00
#master_tree_after
2014-05-26 22:50:46 +00:00
tree_list " $MASTER_SYNC_DIR " master " $TREE_AFTER_FILENAME "
if [ $? = = 0 ]
then
echo " ${ SYNC_ACTION [8] } .success " > " $MASTER_LAST_ACTION "
else
echo " ${ SYNC_ACTION [8] } .fail " > " $MASTER_LAST_ACTION "
fi
2013-07-30 22:18:39 +00:00
resume_sync = "resumed"
fi
2014-05-26 22:50:46 +00:00
if [ " $resume_sync " = = "resumed" ] || [ " $resume_sync " = = " ${ SYNC_ACTION [8] } .success " ] || [ " $resume_sync " = = " ${ SYNC_ACTION [9] } .fail " ]
2013-07-30 22:18:39 +00:00
then
2013-11-04 21:11:43 +00:00
#slave_tree_after
2014-05-26 22:50:46 +00:00
tree_list " $SLAVE_SYNC_DIR " slave " $TREE_AFTER_FILENAME "
if [ $? = = 0 ]
then
echo " ${ SYNC_ACTION [9] } .success " > " $MASTER_LAST_ACTION "
else
echo " ${ SYNC_ACTION [9] } .fail " > " $MASTER_LAST_ACTION "
fi
2013-07-30 22:18:39 +00:00
resume_sync = "resumed"
fi
2013-07-15 22:10:23 +00:00
Log "Finished synchronization task."
2014-05-26 22:50:46 +00:00
echo " ${ SYNC_ACTION [10] } " > " $MASTER_LAST_ACTION "
2014-01-19 19:31:14 +00:00
2014-05-26 22:50:46 +00:00
echo "0" > " $MASTER_RESUME_COUNT "
2013-07-18 20:41:31 +00:00
}
2013-07-15 22:10:23 +00:00
function SoftDelete
2013-06-18 11:34:14 +00:00
{
2013-11-02 22:33:54 +00:00
if [ " $CONFLICT_BACKUP " != "no" ] && [ $CONFLICT_BACKUP_DAYS -ne 0 ]
2013-07-16 11:55:15 +00:00
then
2014-01-19 19:31:14 +00:00
if [ -d " $MASTER_SYNC_DIR $MASTER_BACKUP_DIR " ]
2013-07-16 11:55:15 +00:00
then
2013-08-03 21:06:09 +00:00
if [ $dryrun -eq 1 ]
then
2014-03-31 21:03:51 +00:00
Log " Listing backups older than $CONFLICT_BACKUP_DAYS days on master replica. Won't remove anything. "
2014-05-08 10:36:36 +00:00
if [ $verbose -eq 1 ]
then
$FIND_CMD " $MASTER_SYNC_DIR $MASTER_BACKUP_DIR / " -ctime +$CONFLICT_BACKUP_DAYS &
else
$FIND_CMD " $MASTER_SYNC_DIR $MASTER_BACKUP_DIR / " -ctime +$CONFLICT_BACKUP_DAYS > /dev/null &
fi
2013-08-03 21:06:09 +00:00
else
2014-03-31 21:03:51 +00:00
Log " Removing backups older than $CONFLICT_BACKUP_DAYS days on master replica. "
2014-01-19 19:31:14 +00:00
$FIND_CMD " $MASTER_SYNC_DIR $MASTER_BACKUP_DIR / " -ctime +$CONFLICT_BACKUP_DAYS -exec rm -rf '{}' \; &
2013-08-04 13:20:26 +00:00
fi
child_pid = $!
WaitForCompletion $child_pid $SOFT_MAX_EXEC_TIME 0
retval = $?
if [ $retval -ne 0 ]
then
LogError "Error while executing conflict backup cleanup on master replica."
else
Log "Conflict backup cleanup complete on master replica."
2013-08-03 21:06:09 +00:00
fi
2014-01-19 19:31:14 +00:00
elif [ -d " $MASTER_SYNC_DIR $MASTER_BACKUP_DIR " ] && ! [ -w " $MASTER_SYNC_DIR $MASTER_BACKUP_DIR " ]
2013-11-02 20:57:15 +00:00
then
2014-01-19 19:31:14 +00:00
LogError " Warning: Master replica conflict backup dir [ $MASTER_SYNC_DIR $MASTER_BACKUP_DIR ] isn't writable. Cannot clean old files. "
2013-07-16 11:55:15 +00:00
fi
2014-05-25 17:09:30 +00:00
2013-07-21 19:40:55 +00:00
if [ " $REMOTE_SYNC " = = "yes" ]
2013-07-16 11:55:15 +00:00
then
2013-08-24 17:51:39 +00:00
CheckConnectivity3rdPartyHosts
CheckConnectivityRemoteHost
2013-08-03 21:06:09 +00:00
if [ $dryrun -eq 1 ]
then
2014-03-31 21:03:51 +00:00
Log " Listing backups older than $CONFLICT_BACKUP_DAYS days on slave replica. Won't remove anything. "
2015-01-16 09:55:01 +00:00
eval " $SSH_CMD \"if [ -w \\\" $SLAVE_SYNC_DIR $SLAVE_BACKUP_DIR \\\" ]; then $COMMAND_SUDO $REMOTE_FIND_CMD \\\" $SLAVE_SYNC_DIR $SLAVE_BACKUP_DIR /\\\" -ctime + $CONFLICT_BACKUP_DAYS ; fi\" " &
2013-08-03 21:06:09 +00:00
else
2014-03-31 21:03:51 +00:00
Log " Removing backups older than $CONFLICT_BACKUP_DAYS days on remote slave replica. "
2015-01-16 09:55:01 +00:00
eval " $SSH_CMD \"if [ -w \\\" $SLAVE_SYNC_DIR $SLAVE_BACKUP_DIR \\\" ]; then $COMMAND_SUDO $REMOTE_FIND_CMD \\\" $SLAVE_SYNC_DIR $SLAVE_BACKUP_DIR /\\\" -ctime + $CONFLICT_BACKUP_DAYS -exec rm -rf '{}' \;; fi\" " &
2013-08-03 21:06:09 +00:00
fi
2013-08-04 13:20:26 +00:00
child_pid = $!
WaitForCompletion $child_pid $SOFT_MAX_EXEC_TIME 0
retval = $?
if [ $retval -ne 0 ]
then
LogError "Error while executing conflict backup cleanup on slave replica."
else
Log "Conflict backup cleanup complete on slave replica."
fi
2013-07-21 19:40:55 +00:00
else
2014-01-19 19:31:14 +00:00
if [ -w " $SLAVE_SYNC_DIR $SLAVE_BACKUP_DIR " ]
2013-07-21 19:40:55 +00:00
then
2013-08-03 21:06:09 +00:00
if [ $dryrun -eq 1 ]
then
2014-03-31 21:03:51 +00:00
Log " Listing backups older than $CONFLICT_BACKUP_DAYS days on slave replica. Won't remove anything. "
2015-01-16 09:55:01 +00:00
$FIND_CMD " $SLAVE_SYNC_DIR $SLAVE_BACKUP_DIR / " -ctime +$CONFLICT_BACKUP_DAYS &
2013-08-03 21:06:09 +00:00
else
2014-03-31 21:03:51 +00:00
Log " Removing backups older than $CONFLICT_BACKUP_DAYS days on slave replica. "
2015-01-16 09:55:01 +00:00
$FIND_CMD " $SLAVE_SYNC_DIR $SLAVE_BACKUP_DIR / " -ctime +$CONFLICT_BACKUP_DAYS -exec rm -rf '{}' \; &
2013-08-03 21:06:09 +00:00
fi
2013-08-04 13:20:26 +00:00
child_pid = $!
WaitForCompletion $child_pid $SOFT_MAX_EXEC_TIME 0
retval = $?
if [ $retval -ne 0 ]
then
LogError "Error while executing conflict backup cleanup on slave replica."
else
Log "Conflict backup cleanup complete on slave replica."
fi
2014-01-19 19:31:14 +00:00
elif [ -d " $SLAVE_SYNC_DIR $SLAVE_BACKUP_DIR " ] && ! [ -w " $SLAVE_SYNC_DIR $SLAVE_BACKUP_DIR " ]
2013-11-02 20:57:15 +00:00
then
2014-01-19 19:31:14 +00:00
LogError " Warning: Slave replica conflict backup dir [ $SLAVE_SYNC_DIR $SLAVE_BACKUP_DIR ] isn't writable. Cannot clean old files. "
2013-07-21 19:40:55 +00:00
fi
2013-07-16 11:55:15 +00:00
fi
fi
2013-11-02 22:33:54 +00:00
if [ " $SOFT_DELETE " != "no" ] && [ $SOFT_DELETE_DAYS -ne 0 ]
2013-07-16 11:55:15 +00:00
then
2014-05-08 10:36:36 +00:00
if [ -d " $MASTER_SYNC_DIR $MASTER_DELETE_DIR " ]
2013-07-16 11:55:15 +00:00
then
2013-08-03 21:06:09 +00:00
if [ $dryrun -eq 1 ]
then
2014-03-31 21:03:51 +00:00
Log " Listing soft deleted items older than $SOFT_DELETE_DAYS days on master replica. Won't remove anything. "
2015-01-16 09:55:01 +00:00
$FIND_CMD " $MASTER_SYNC_DIR $MASTER_DELETE_DIR / " -ctime +$SOFT_DELETE_DAYS &
2013-08-03 21:06:09 +00:00
else
2014-03-31 21:03:51 +00:00
Log " Removing soft deleted items older than $SOFT_DELETE_DAYS days on master replica. "
2015-01-16 09:55:01 +00:00
$FIND_CMD " $MASTER_SYNC_DIR $MASTER_DELETE_DIR / " -ctime +$SOFT_DELETE_DAYS -exec rm -rf '{}' \; &
2013-08-03 21:06:09 +00:00
fi
2013-08-04 13:20:26 +00:00
child_pid = $!
WaitForCompletion $child_pid $SOFT_MAX_EXEC_TIME 0
retval = $?
if [ $retval -ne 0 ]
then
LogError "Error while executing soft delete cleanup on master replica."
else
Log "Soft delete cleanup complete on master replica."
fi
2014-01-19 19:31:14 +00:00
elif [ -d " $MASTER_SYNC_DIR $MASTER_DELETE_DIR " ] && ! [ -w " $MASTER_SYNC_DIR $MASTER_DELETE_DIR " ]
2013-11-02 20:57:15 +00:00
then
2014-01-19 19:31:14 +00:00
LogError " Warning: Master replica deletion backup dir [ $MASTER_SYNC_DIR $MASTER_DELETE_DIR ] isn't writable. Cannot clean old files. "
2013-07-16 11:55:15 +00:00
fi
2013-07-21 19:40:55 +00:00
if [ " $REMOTE_SYNC " = = "yes" ]
2013-07-16 11:55:15 +00:00
then
2013-08-24 17:51:39 +00:00
CheckConnectivity3rdPartyHosts
CheckConnectivityRemoteHost
2013-08-03 21:06:09 +00:00
if [ $dryrun -eq 1 ]
then
2014-03-31 21:03:51 +00:00
Log " Listing soft deleted items older than $SOFT_DELETE_DAYS days on slave replica. Won't remove anything. "
2015-01-16 09:55:01 +00:00
eval " $SSH_CMD \"if [ -w \\\" $SLAVE_SYNC_DIR $SLAVE_DELETE_DIR \\\" ]; then $COMMAND_SUDO $REMOTE_FIND_CMD \\\" $SLAVE_SYNC_DIR $SLAVE_DELETE_DIR /\\\" -ctime + $SOFT_DELETE_DAYS ; fi\" " &
2013-08-03 21:06:09 +00:00
else
2014-03-31 21:03:51 +00:00
Log " Removing soft deleted items older than $SOFT_DELETE_DAYS days on remote slave replica. "
2015-01-16 09:55:01 +00:00
eval " $SSH_CMD \"if [ -w \\\" $SLAVE_SYNC_DIR $SLAVE_DELETE_DIR \\\" ]; then $COMMAND_SUDO $REMOTE_FIND_CMD \\\" $SLAVE_SYNC_DIR $SLAVE_DELETE_DIR /\\\" -ctime + $SOFT_DELETE_DAYS -exec rm -rf '{}' \;; fi\" " &
2013-08-03 21:06:09 +00:00
fi
2013-08-04 13:20:26 +00:00
child_pid = $!
WaitForCompletion $child_pid $SOFT_MAX_EXEC_TIME 0
retval = $?
if [ $retval -ne 0 ]
then
LogError "Error while executing soft delete cleanup on slave replica."
else
Log "Soft delete cleanup complete on slave replica."
fi
2013-07-21 19:40:55 +00:00
else
2014-01-19 19:31:14 +00:00
if [ -w " $SLAVE_SYNC_DIR $SLAVE_DELETE_DIR " ]
2013-07-21 19:40:55 +00:00
then
2013-08-03 21:06:09 +00:00
if [ $dryrun -eq 1 ]
then
2014-03-31 21:03:51 +00:00
Log " Listing soft deleted items older than $SOFT_DELETE_DAYS days on slave replica. Won't remove anything. "
2015-01-16 09:55:01 +00:00
$FIND_CMD " $SLAVE_SYNC_DIR $SLAVE_DELETE_DIR / " -ctime +$SOFT_DELETE_DAYS &
2013-08-03 21:06:09 +00:00
else
2014-03-31 21:03:51 +00:00
Log " Removing soft deleted items older than $SOFT_DELETE_DAYS days on slave replica. "
2015-01-16 09:55:01 +00:00
$FIND_CMD " $SLAVE_SYNC_DIR $SLAVE_DELETE_DIR / " -ctime +$SOFT_DELETE_DAYS -exec rm -rf '{}' \; &
2013-08-03 21:06:09 +00:00
fi
2013-08-04 13:20:26 +00:00
child_pid = $!
WaitForCompletion $child_pid $SOFT_MAX_EXEC_TIME 0
retval = $?
if [ $retval -ne 0 ]
then
LogError "Error while executing soft delete cleanup on slave replica."
else
Log "Soft delete cleanup complete on slave replica."
fi
2014-01-19 19:31:14 +00:00
elif [ -d " $SLAVE_SYNC_DIR $SLAVE_DELETE_DIR " ] && ! [ -w " $SLAVE_SYNC_DIR $SLAVE_DELETE_DIR " ]
2013-11-02 20:57:15 +00:00
then
2014-01-19 19:31:14 +00:00
LogError " Warning: Slave replica deletion backup dir [ $SLAVE_SYNC_DIR $SLAVE_DELETE_DIR ] isn't writable. Cannot clean old files. "
2013-07-21 19:40:55 +00:00
fi
2013-07-16 11:55:15 +00:00
fi
fi
2013-07-15 22:10:23 +00:00
}
function Init
{
# Set error exit code if a piped command fails
set -o pipefail
set -o errtrace
2013-11-18 21:44:20 +00:00
# Do not use exit and quit traps if osync runs in monitor mode
if [ $sync_on_changes -eq 0 ]
then
trap TrapStop SIGINT SIGKILL SIGHUP SIGTERM SIGQUIT
2014-01-19 19:31:14 +00:00
trap TrapQuit SIGKILL EXIT
else
trap TrapQuit SIGTERM EXIT SIGKILL SIGHUP SIGQUIT
2013-11-18 21:44:20 +00:00
fi
2013-07-15 22:10:23 +00:00
if [ " $DEBUG " = = "yes" ]
2013-06-18 11:34:14 +00:00
then
2013-07-24 08:38:42 +00:00
trap 'TrapError ${LINENO} $?' ERR
2013-06-18 11:34:14 +00:00
fi
2013-07-15 22:10:23 +00:00
2014-03-31 15:51:21 +00:00
MAIL_ALERT_MSG = " Warning: Execution of osync instance $OSYNC_ID (pid $SCRIPT_PID ) as $LOCAL_USER @ $LOCAL_HOST produced errors on $( date) . "
2013-07-15 22:10:23 +00:00
2013-11-14 20:20:13 +00:00
## Test if slave dir is a ssh uri, and if yes, break it down it its values
if [ " ${ SLAVE_SYNC_DIR : 0 : 6 } " = = "ssh://" ]
then
2013-11-18 20:16:31 +00:00
REMOTE_SYNC = "yes"
2013-11-14 20:20:13 +00:00
# remove leadng 'ssh://'
uri = ${ SLAVE_SYNC_DIR #ssh : //* }
# remove everything after '@'
2013-11-18 20:16:31 +00:00
_first_part = ${ uri %@* }
REMOTE_USER = ${ _first_part %;* }
#fingerprint=${_first_part#*fingerprint=}
if [ " $SSH_RSA_PRIVATE_KEY " = = "" ]
then
SSH_RSA_PRIVATE_KEY = ~/.ssh/id_rsa
fi
2013-11-14 20:20:13 +00:00
# remove everything before '@'
2013-11-18 20:16:31 +00:00
_last_part = ${ uri #*@ }
_last_part2 = ${ _last_part %%/* }
# remove last part if no port defined
REMOTE_HOST = ${ _last_part2 %% : * }
if [ [ " $_last_part2 " = = *":" * ] ]
then
REMOTE_PORT = ${ _last_part2 ##* : }
else
REMOTE_PORT = 22
fi
SLAVE_SYNC_DIR = ${ _last_part #*/ }
2013-11-14 20:20:13 +00:00
fi
2014-01-19 19:31:14 +00:00
## Make sure there is only one trailing slash on path
MASTER_SYNC_DIR = " ${ MASTER_SYNC_DIR %/ } / "
SLAVE_SYNC_DIR = " ${ SLAVE_SYNC_DIR %/ } / "
2013-07-24 08:38:42 +00:00
2014-01-19 19:31:14 +00:00
MASTER_STATE_DIR = " $MASTER_SYNC_DIR $OSYNC_DIR /state "
SLAVE_STATE_DIR = " $SLAVE_SYNC_DIR $OSYNC_DIR /state "
2013-11-04 21:11:43 +00:00
STATE_DIR = " $OSYNC_DIR /state "
2014-01-19 19:31:14 +00:00
MASTER_LOCK = " $MASTER_STATE_DIR /lock "
SLAVE_LOCK = " $SLAVE_STATE_DIR /lock "
2013-07-15 22:10:23 +00:00
## Working directories to keep backups of updated / deleted files
2013-07-24 08:38:42 +00:00
MASTER_BACKUP_DIR = " $OSYNC_DIR /backups "
MASTER_DELETE_DIR = " $OSYNC_DIR /deleted "
SLAVE_BACKUP_DIR = " $OSYNC_DIR /backups "
SLAVE_DELETE_DIR = " $OSYNC_DIR /deleted "
2014-05-25 17:09:30 +00:00
2014-11-24 18:26:17 +00:00
## Partial downloads dirs
2014-11-24 23:38:03 +00:00
PARTIAL_DIR = $OSYNC_DIR "_partial"
2014-11-24 18:26:17 +00:00
2013-07-17 09:34:05 +00:00
## SSH compression
2013-11-03 19:29:17 +00:00
if [ " $SSH_COMPRESSION " != "no" ]
2013-07-17 09:34:05 +00:00
then
SSH_COMP = -C
else
SSH_COMP =
fi
2013-07-20 11:43:11 +00:00
## Define which runner (local bash or distant ssh) to use for standard commands and rsync commands
2013-07-16 11:55:15 +00:00
if [ " $REMOTE_SYNC " = = "yes" ]
then
2013-10-10 18:17:40 +00:00
SSH_CMD = " $( type -p ssh) $SSH_COMP -i $SSH_RSA_PRIVATE_KEY $REMOTE_USER @ $REMOTE_HOST -p $REMOTE_PORT "
2014-05-25 15:51:05 +00:00
SCP_CMD = " $( type -p scp) $SSH_COMP -i $SSH_RSA_PRIVATE_KEY -P $REMOTE_PORT "
2013-10-10 18:17:40 +00:00
RSYNC_SSH_CMD = " $( type -p ssh) $SSH_COMP -i $SSH_RSA_PRIVATE_KEY -p $REMOTE_PORT "
2013-07-16 11:55:15 +00:00
fi
2013-07-16 21:06:26 +00:00
2013-10-10 18:28:40 +00:00
## Support for older config files without RSYNC_EXECUTABLE option
2013-07-22 09:34:58 +00:00
if [ " $RSYNC_EXECUTABLE " = = "" ]
then
RSYNC_EXECUTABLE = rsync
fi
2013-10-10 18:28:40 +00:00
## Sudo execution option
2013-07-22 09:34:58 +00:00
if [ " $SUDO_EXEC " = = "yes" ]
then
2013-10-10 18:28:40 +00:00
if [ " $RSYNC_REMOTE_PATH " != "" ]
then
2014-03-09 16:54:45 +00:00
RSYNC_PATH = " sudo $RSYNC_REMOTE_PATH / $RSYNC_EXECUTABLE "
2013-10-10 18:28:40 +00:00
else
RSYNC_PATH = " sudo $RSYNC_EXECUTABLE "
fi
2013-07-22 09:34:58 +00:00
COMMAND_SUDO = "sudo"
else
2013-10-10 18:28:40 +00:00
if [ " $RSYNC_REMOTE_PATH " != "" ]
2014-03-09 16:54:45 +00:00
then
RSYNC_PATH = " $RSYNC_REMOTE_PATH / $RSYNC_EXECUTABLE "
else
RSYNC_PATH = " $RSYNC_EXECUTABLE "
fi
2013-07-22 09:34:58 +00:00
COMMAND_SUDO = ""
fi
2014-05-21 16:33:16 +00:00
## Set rsync default arguments
RSYNC_ARGS = "-rlptgoD"
2013-09-10 09:55:34 +00:00
if [ " $PRESERVE_ACL " = = "yes" ]
2013-07-22 09:34:58 +00:00
then
2014-05-27 09:35:45 +00:00
RSYNC_ARGS = $RSYNC_ARGS " -A"
2013-07-22 09:34:58 +00:00
fi
if [ " $PRESERVE_XATTR " = = "yes" ]
then
2014-05-27 09:35:45 +00:00
RSYNC_ARGS = $RSYNC_ARGS " -X"
2013-07-22 09:34:58 +00:00
fi
if [ " $RSYNC_COMPRESS " = = "yes" ]
then
2014-05-27 09:35:45 +00:00
RSYNC_ARGS = $RSYNC_ARGS " -z"
2013-07-22 09:34:58 +00:00
fi
2014-05-27 09:35:45 +00:00
if [ " $COPY_SYMLINKS " = = "yes" ]
then
RSYNC_ARGS = $RSYNC_ARGS " -L"
fi
2014-05-27 17:58:59 +00:00
if [ " $KEEP_DIRLINKS " = = "yes" ]
then
RSYNC_ARGS = $RSYNC_ARGS " -K"
fi
2014-05-08 20:08:15 +00:00
if [ " $PRESERVE_HARDLINKS " = = "yes" ]
2014-05-08 10:36:36 +00:00
then
2014-05-27 09:35:45 +00:00
RSYNC_ARGS = $RSYNC_ARGS " -H"
2014-05-08 10:36:36 +00:00
fi
2013-07-16 21:06:26 +00:00
if [ $dryrun -eq 1 ]
then
2014-05-27 09:35:45 +00:00
RSYNC_ARGS = $RSYNC_ARGS " -n"
2013-07-16 21:06:26 +00:00
DRY_WARNING = "/!\ DRY RUN"
2013-07-22 09:34:58 +00:00
fi
2013-07-16 21:33:30 +00:00
2013-11-02 20:57:15 +00:00
if [ " $BANDWIDTH " != "" ] && [ " $BANDWIDTH " != "0" ]
2013-08-04 13:20:26 +00:00
then
RSYNC_ARGS = $RSYNC_ARGS " --bwlimit= $BANDWIDTH "
fi
2014-05-25 15:51:05 +00:00
## Set sync only function arguments for rsync
SYNC_OPTS = "-u"
2014-05-25 17:09:30 +00:00
2014-05-25 15:51:05 +00:00
if [ $verbose -eq 1 ]
then
SYNC_OPTS = $SYNC_OPTS "i"
fi
if [ $stats -eq 1 ]
then
SYNC_OPTS = $SYNC_OPTS " --stats"
fi
2014-11-24 18:26:17 +00:00
if [ " $PARTIAL " = = "yes" ]
then
SYNC_OPTS = $SYNC_OPTS " --partial --partial-dir=\" $PARTIAL_DIR \" "
2014-11-26 10:25:58 +00:00
RSYNC_EXCLUDE = " $RSYNC_EXCLUDE --exclude=\" $PARTIAL_DIR \" "
2014-11-24 18:26:17 +00:00
fi
2013-07-16 21:33:30 +00:00
## Conflict options
if [ " $CONFLICT_BACKUP " != "no" ]
then
2013-07-23 18:57:38 +00:00
MASTER_BACKUP = " --backup --backup-dir=\" $MASTER_BACKUP_DIR \" "
SLAVE_BACKUP = " --backup --backup-dir=\" $SLAVE_BACKUP_DIR \" "
2013-07-19 10:49:40 +00:00
if [ " $CONFLICT_BACKUP_MULTIPLE " = = "yes" ]
then
MASTER_BACKUP = " $MASTER_BACKUP --suffix . $( date +%Y.%m.%d-%H.%M.%S) "
SLAVE_BACKUP = " $SLAVE_BACKUP --suffix . $( date +%Y.%m.%d-%H.%M.%S) "
fi
2013-07-16 21:33:30 +00:00
else
2013-07-19 10:49:40 +00:00
MASTER_BACKUP =
SLAVE_BACKUP =
2013-07-16 21:33:30 +00:00
fi
2013-07-19 16:15:25 +00:00
## Add Rsync exclude patterns
RsyncExcludePattern
2014-05-08 10:36:36 +00:00
## Add Rsync exclude from file
RsyncExcludeFrom
2014-05-26 22:50:46 +00:00
## Filenames for state files
if [ $dryrun -eq 1 ]
then
dry_suffix = "-dry"
fi
TREE_CURRENT_FILENAME = " -tree-current- $SYNC_ID $dry_suffix "
TREE_AFTER_FILENAME = " -tree-after- $SYNC_ID $dry_suffix "
2014-05-27 10:47:50 +00:00
TREE_AFTER_FILENAME_NO_SUFFIX = " -tree-after- $SYNC_ID "
2014-07-08 00:00:23 +00:00
DELETED_LIST_FILENAME = " -deleted-list- $SYNC_ID $dry_suffix "
FAILED_DELETE_LIST_FILENAME = " -failed-delete- $SYNC_ID $dry_suffix "
2014-05-26 22:50:46 +00:00
MASTER_LAST_ACTION = " $MASTER_STATE_DIR /last-action- $SYNC_ID $dry_suffix "
MASTER_RESUME_COUNT = " $MASTER_STATE_DIR /resume-count- $SYNC_ID $dry_suffix "
## Sync function actions (0-9)
SYNC_ACTION = (
'master-replica-tree'
'slave-replica-tree'
'master-deleted-list'
'slave-deleted-list'
'update-master-replica'
'update-slave-replica'
'delete-propagation-slave'
'delete-propagation-master'
'master-replica-tree-after'
'slave-replica-tree-after'
'sync.success'
)
2014-09-22 19:21:37 +00:00
## Set compression executable and extension
COMPRESSION_LEVEL = 9
if type -p xz > /dev/null 2>& 1
then
COMPRESSION_PROGRAM = " | xz - $COMPRESSION_LEVEL "
COMPRESSION_EXTENSION = .xz
elif type -p lzma > /dev/null 2>& 1
then
COMPRESSION_PROGRAM = " | lzma - $COMPRESSION_LEVEL "
COMPRESSION_EXTENSION = .lzma
elif type -p pigz > /dev/null 2>& 1
then
COMPRESSION_PROGRAM = " | pigz - $COMPRESSION_LEVEL "
COMPRESSION_EXTENSION = .gz
COMPRESSION_OPTIONS = --rsyncable
elif type -p gzip > /dev/null 2>& 1
then
COMPRESSION_PROGRAM = " | gzip - $COMPRESSION_LEVEL "
COMPRESSION_EXTENSION = .gz
COMPRESSION_OPTIONS = --rsyncable
else
COMPRESSION_PROGRAM =
COMPRESSION_EXTENSION =
fi
ALERT_LOG_FILE = " $ALERT_LOG_FILE $COMPRESSION_EXTENSION "
2014-05-26 22:50:46 +00:00
}
function InitLocalOSSettings
{
2014-11-24 09:12:48 +00:00
## If running under Msys, some commands don't run the same way
## Using mingw version of find instead of windows one
## Getting running processes is quite different
## Ping command isn't the same
2014-05-26 22:50:46 +00:00
if [ " $LOCAL_OS " = = "msys" ]
then
FIND_CMD = $( dirname $BASH ) /find
2014-11-24 18:26:17 +00:00
## TODO: The following command needs to be checked on msys. Does the $1 variable substitution work ?
PROCESS_TEST_CMD = 'ps -a | awk "{\$1=\$1}\$1" | awk "{print \$1}" | grep $1'
2014-11-24 09:12:48 +00:00
PING_CMD = "ping -n 2"
2014-05-26 22:50:46 +00:00
else
FIND_CMD = find
2014-11-24 18:26:17 +00:00
PROCESS_TEST_CMD = 'ps -p$1'
2014-11-24 09:12:48 +00:00
PING_CMD = "ping -c 2 -i .2"
2014-05-26 22:50:46 +00:00
fi
## Stat command has different syntax on Linux and FreeBSD/MacOSX
if [ " $LOCAL_OS " = = "MacOSX" ] || [ " $LOCAL_OS " = = "BSD" ]
then
STAT_CMD = "stat -f \"%Sm\""
else
STAT_CMD = "stat --format %y"
fi
}
function InitRemoteOSSettings
{
## MacOSX does not use the -E parameter like Linux or BSD does (-E is mapped to extended attrs instead of preserve executability)
if [ " $LOCAL_OS " != "MacOSX" ] && [ " $REMOTE_OS " != "MacOSX" ]
then
2014-05-27 09:35:45 +00:00
RSYNC_ARGS = $RSYNC_ARGS " -E"
2014-05-26 22:50:46 +00:00
fi
if [ " $REMOTE_OS " = = "msys" ]
then
REMOTE_FIND_CMD = $( dirname $BASH ) /find
else
REMOTE_FIND_CMD = find
fi
2013-06-18 11:34:14 +00:00
}
2013-07-15 22:10:23 +00:00
function Main
{
2013-07-20 11:43:11 +00:00
CreateOsyncDirs
2013-07-19 23:00:58 +00:00
LockDirectories
2013-07-15 22:10:23 +00:00
Sync
}
function Usage
2013-06-18 11:34:14 +00:00
{
2014-01-19 19:31:14 +00:00
echo " $PROGRAM $PROGRAM_VERSION $PROGRAM_BUILD "
echo $AUTHOR
echo $CONTACT
2013-07-15 22:10:23 +00:00
echo ""
2013-11-14 20:20:13 +00:00
echo "You may use Osync with a full blown configuration file, or use its default options for quick command line sync."
2014-01-19 19:31:14 +00:00
echo "Usage: osync /path/to/config/file [OPTIONS]"
echo "or osync --master=/path/to/master/replica --slave=/path/to/slave/replica [OPTIONS] [QUICKSYNC OPTIONS]"
echo "or osync --master=/path/to/master/replica --slave=ssh://backupuser@remotehost.com[:portnumber]//path/to/slave/replica [OPTIONS] [QUICKSYNC OPTIONS]"
2013-07-15 22:10:23 +00:00
echo ""
2014-01-19 19:31:14 +00:00
echo "[OPTIONS]"
2013-11-18 22:36:52 +00:00
echo "--dry Will run osync without actually doing anything; just testing"
echo "--silent Will run osync without any output to stdout, used for cron jobs"
echo "--verbose Increases output"
2014-05-27 12:18:48 +00:00
echo "--stats Adds rsync transfer statistics to verbose output"
2014-11-24 23:38:03 +00:00
echo "--partial Allows rsync to keep partial downloads that can be resumed later (experimental)"
2013-11-18 22:36:52 +00:00
echo "--no-maxtime Disables any soft and hard execution time checks"
echo "--force-unlock Will override any existing active or dead locks on master and slave replica"
2014-05-27 12:18:48 +00:00
echo "--on-changes Will launch a sync task after a short wait period if there is some file activity on master replica. You should try daemon mode instead"
2013-11-03 19:29:17 +00:00
echo ""
2013-11-18 22:36:52 +00:00
echo "[QUICKSYNC OPTIONS]"
2014-05-27 12:18:48 +00:00
echo "--master=\"\" Master replica path. Will contain state and backup directory (is mandatory)"
echo "--slave=\"\" Local or remote slave replica path. Can be a ssh uri like ssh://user@host.com:22//path/to/slave/replica (is mandatory)"
2013-11-18 22:36:52 +00:00
echo "--rsakey=\"\" Alternative path to rsa private key for ssh connection to slave replica"
2014-05-27 12:18:48 +00:00
echo "--sync-id=\"\" Optional sync task name to identify this synchronization task when using multiple slaves"
2013-07-15 22:10:23 +00:00
exit 128
}
2013-11-18 21:44:20 +00:00
function SyncOnChanges
{
if ! type -p inotifywait > /dev/null 2>& 1
then
2013-11-25 11:34:42 +00:00
LogError "No inotifywait command found. Cannot monitor changes."
2013-11-18 21:44:20 +00:00
exit 1
fi
2014-05-25 17:09:30 +00:00
Log "#### Running Osync in file monitor mode."
2013-11-18 21:50:07 +00:00
2013-11-18 21:44:20 +00:00
while true
do
2013-11-25 12:20:53 +00:00
if [ " $ConfigFile " != "" ]
then
cmd = " bash $osync_cmd \" $ConfigFile \" $opts --no-locks "
else
cmd = " bash $osync_cmd $opts --no-locks "
fi
eval $cmd
2014-05-27 18:08:07 +00:00
retval = $?
2014-05-27 17:58:59 +00:00
if [ $retval != 0 ]
2014-01-19 19:31:14 +00:00
then
LogError "osync child exited with error."
2014-05-27 17:58:59 +00:00
exit $retval
2014-01-19 19:31:14 +00:00
fi
Log "#### Monitoring now."
inotifywait --exclude $OSYNC_DIR $RSYNC_EXCLUDE -qq -r -e create -e modify -e delete -e move -e attrib " $MASTER_SYNC_DIR " &
sub_pid = $!
wait $sub_pid
Log " #### Changes detected, waiting $MIN_WAIT seconds before running next sync. "
sleep $MIN_WAIT
2013-11-18 21:44:20 +00:00
done
}
2013-07-15 22:10:23 +00:00
# Comand line argument flags
dryrun = 0
silent = 0
2014-11-28 11:10:00 +00:00
if [ " $DEBUG " = = "yes" ]
then
verbose = 1
else
verbose = 0
fi
2014-05-25 15:51:05 +00:00
stats = 0
2014-11-24 18:26:17 +00:00
PARTIAL = 0
2013-07-21 19:40:55 +00:00
force_unlock = 0
2013-08-04 07:47:47 +00:00
no_maxtime = 0
2013-07-15 22:10:23 +00:00
# Alert flags
2013-11-18 22:50:39 +00:00
opts = ""
2013-07-15 22:10:23 +00:00
soft_alert_total = 0
error_alert = 0
2013-07-16 21:06:26 +00:00
soft_stop = 0
2013-11-03 19:29:17 +00:00
quick_sync = 0
2013-11-18 21:44:20 +00:00
sync_on_changes = 0
2013-11-25 12:20:53 +00:00
nolocks = 0
2013-11-18 21:44:20 +00:00
osync_cmd = $0
2013-07-15 22:10:23 +00:00
if [ $# -eq 0 ]
then
Usage
fi
for i in " $@ "
do
case $i in
--dry)
dryrun = 1
2013-11-18 22:50:39 +00:00
opts = $opts " --dry"
2013-07-15 22:10:23 +00:00
; ;
--silent)
silent = 1
2013-11-18 22:50:39 +00:00
opts = $opts " --silent"
2013-07-15 22:10:23 +00:00
; ;
2013-07-20 11:43:11 +00:00
--verbose)
verbose = 1
2013-11-18 22:50:39 +00:00
opts = $opts " --verbose"
2013-07-20 11:43:11 +00:00
; ;
2014-05-25 15:51:05 +00:00
--stats)
stats = 1
opts = $opts " --stats"
; ;
2014-11-24 18:26:17 +00:00
--partial)
PARTIAL = "yes"
opts = $opts " --partial"
; ;
2013-07-21 19:40:55 +00:00
--force-unlock)
force_unlock = 1
2013-11-18 22:50:39 +00:00
opts = $opts " --force-unlock"
2013-07-21 19:40:55 +00:00
; ;
2013-08-04 07:47:47 +00:00
--no-maxtime)
no_maxtime = 1
2013-11-18 22:50:39 +00:00
opts = $opts " --no-maxtime"
2013-08-04 07:47:47 +00:00
; ;
2013-07-20 11:43:11 +00:00
--help| -h| --version| -v)
2013-07-15 22:10:23 +00:00
Usage
; ;
2013-11-03 19:29:17 +00:00
--master= *)
quick_sync = $(( $quick_sync + 1 ))
no_maxtime = 1
MASTER_SYNC_DIR = ${ i ##*= }
2013-11-25 12:20:53 +00:00
opts = $opts " --master=\" $MASTER_SYNC_DIR \" "
2013-11-03 19:29:17 +00:00
; ;
--slave= *)
quick_sync = $(( $quick_sync + 1 ))
SLAVE_SYNC_DIR = ${ i ##*= }
2013-11-25 12:20:53 +00:00
opts = $opts " --slave=\" $SLAVE_SYNC_DIR \" "
2013-11-03 19:29:17 +00:00
no_maxtime = 1
; ;
2013-11-18 20:16:31 +00:00
--rsakey= *)
SSH_RSA_PRIVATE_KEY = ${ i ##*= }
2013-11-25 12:20:53 +00:00
opts = $opts " --rsakey=\" $SSH_RSA_PRIVATE_KEY \" "
2013-11-18 20:16:31 +00:00
; ;
2014-05-08 10:36:36 +00:00
--sync-id= *)
SYNC_ID = ${ i ##*= }
opts = $opts " --sync-id=\" $SYNC_ID \" "
; ;
2013-11-18 21:44:20 +00:00
--on-changes)
sync_on_changes = 1
; ;
2013-11-25 12:20:53 +00:00
--no-locks)
nolocks = 1
; ;
2013-07-15 22:10:23 +00:00
esac
done
2013-11-25 12:20:53 +00:00
# Remove leading space if there is one
opts = " ${ opts # * } "
2013-07-15 22:10:23 +00:00
CheckEnvironment
if [ $? = = 0 ]
then
2014-05-08 10:36:36 +00:00
## Here we set default options for quicksync tasks when no configuration file is provided.
2013-11-03 19:29:17 +00:00
if [ $quick_sync -eq 2 ]
2013-06-18 11:34:14 +00:00
then
2014-05-08 10:36:36 +00:00
if [ " $SYNC_ID " = = "" ]
then
SYNC_ID = "quicksync task"
fi
2013-11-03 19:29:17 +00:00
MINIMUM_SPACE = 1024
REMOTE_SYNC = no
CONFLICT_BACKUP_DAYS = 30
SOFT_DELETE_DAYS = 30
2013-11-14 20:20:13 +00:00
RESUME_TRY = 1
2014-01-19 19:31:14 +00:00
MIN_WAIT = 30
2013-11-03 19:29:17 +00:00
else
2013-11-18 21:44:20 +00:00
ConfigFile = " $1 "
LoadConfigFile " $ConfigFile "
2013-11-03 19:29:17 +00:00
fi
2014-11-29 14:07:09 +00:00
if [ " $LOGFILE " = = "" ]
then
if [ -w /var/log ]
then
LOG_FILE = /var/log/osync_$SYNC_ID .log
else
LOG_FILE = ./osync_$SYNC_ID .log
fi
else
LOG_FILE = " $LOGFILE "
fi
GetLocalOS
InitLocalOSSettings
2013-11-03 19:29:17 +00:00
Init
2014-05-26 22:50:46 +00:00
GetRemoteOS
InitRemoteOSSettings
2013-11-18 21:44:20 +00:00
if [ $sync_on_changes -eq 1 ]
then
2014-03-23 20:57:57 +00:00
SyncOnChanges
2014-03-09 16:54:45 +00:00
else
DATE = $( date)
Log "-------------------------------------------------------------"
Log " $DRY_WARNING $DATE - $PROGRAM $PROGRAM_VERSION script begin. "
Log "-------------------------------------------------------------"
Log " Sync task [ $SYNC_ID ] launched as $LOCAL_USER @ $LOCAL_HOST (PID $SCRIPT_PID ) "
if [ $no_maxtime -eq 1 ]
then
SOFT_MAX_EXEC_TIME = 0
HARD_MAX_EXEC_TIME = 0
fi
CheckMasterSlaveDirs
CheckMinimumSpace
2013-07-15 22:10:23 +00:00
if [ $? = = 0 ]
then
2014-03-09 16:54:45 +00:00
RunBeforeHook
Main
if [ $? = = 0 ]
then
SoftDelete
fi
RunAfterHook
2013-06-18 11:34:14 +00:00
fi
fi
2013-07-15 22:10:23 +00:00
else
LogError "Environment not suitable to run osync."
2013-10-10 18:17:40 +00:00
exit 1
2013-07-15 22:10:23 +00:00
fi